'       ---------------------------------------------------------------------
'        BTISAM.BI Include file for BTISAM.MOD                        930822
'       ---------------------------------------------------------------------
	DECLARE SUB BTRVFAR (op%, status%, sPosBlock$, pDataBuf%, pd%, dLen%, keybuf$, keynum%)

	DECLARE FUNCTION BtBof% (bt AS ANY)
	DECLARE FUNCTION BtClearOwner% (bt AS ANY)
	DECLARE FUNCTION BtClose% (bt AS ANY)
	DECLARE FUNCTION BtCreate% (sFileName$, btcf AS ANY, btck() AS ANY, altcol$, bt AS ANY)
	DECLARE FUNCTION BtDelete% (bt AS ANY)
	DECLARE FUNCTION BtEof% (bt AS ANY)
	DECLARE FUNCTION BtGetEqual% (bt AS ANY, pRec&, lenRec%, key$, bLock%)
	DECLARE FUNCTION BtGetFirst% (bt AS ANY, pRec&, lenRec%, bLock%)
	DECLARE FUNCTION BtGetGE% (bt AS ANY, pRec&, lenRec%, key$, bLock%)
	DECLARE FUNCTION BtGetGreater% (bt AS ANY, pRec&, lenRec%, key$, bLock%)
	DECLARE FUNCTION BtGetLast% (bt AS ANY, pRec&, lenRec%, bLock%)
	DECLARE FUNCTION BtGetLE% (bt AS ANY, pRec&, lenRec%, key$, bLock%)
	DECLARE FUNCTION BtGetLess% (bt AS ANY, pRec&, lenRec%, key$, bLock%)
	DECLARE FUNCTION BtGetNext% (bt AS ANY, pRec&, lenRec%, bLock%)
	DECLARE FUNCTION BtGetPrevious% (bt AS ANY, pRec&, lenRec%, bLock%)
	DECLARE FUNCTION BtInsert% (bt AS ANY, pRec&, lenRec%)
	DECLARE SUB BtIsam (op%, status%, sPB$, pDataBuf&, bLen%, kb$, k%)
	DECLARE FUNCTION BtLof& (bt AS ANY)
	DECLARE FUNCTION BtOpen% (sFileName$, sOwner$, iMode%, bt AS ANY)
	DECLARE FUNCTION BtSetOwner% (bt AS ANY, sOwner$, iRestrict%)
	DECLARE FUNCTION BtUpdate% (bt AS ANY, pRec&, lenRec%)
	DECLARE FUNCTION BtReset% (bt AS ANY, sConnectId$)
	DECLARE FUNCTION BtTransAbort% (bt AS ANY)
	DECLARE FUNCTION BtTransBegin% (bt AS ANY)
	DECLARE FUNCTION BtTransEnd% (bt AS ANY)
	DECLARE FUNCTION BtUnlock% (bt AS ANY)
	DECLARE FUNCTION BtError$ (iErrId%)


	TYPE BTCFILESPECTYPE
	     recordlen  AS INTEGER
	     pagesize   AS INTEGER
	     indexcount AS INTEGER
	     reccount   AS LONG
	     fileflag   AS INTEGER
	     resword    AS INTEGER
	     allocation AS INTEGER
	END TYPE

	TYPE BTCKEYSPECTYPE
	     keypos     AS INTEGER
	     keylen     AS INTEGER
	     keyflags   AS INTEGER
	     numkeys    AS LONG
	     extkey     AS STRING * 1
	     nullval    AS STRING * 1
	     reserved   AS STRING * 4
	END TYPE

	TYPE BTFILETYPE
	     curkey     AS INTEGER
	     posblock   AS STRING * 128
	     status     AS INTEGER
	END TYPE

	' Constants for BtOpen (iMode)
	'
	CONST BTOPENNORMAL = 0
	CONST BTOPENREADONLY = -2
	CONST BTOPENEXCLUSIVE = -4

	' OPcodes for BTRVFAR
	'
	CONST BTOOPEN = 0
	CONST BTOCLOSE = 1
	CONST BTOINSERT = 2
	CONST BTOUPDATE = 3
	CONST BTODELETE = 4
	CONST BTOGETEQUAL = 5
	CONST BTOGETNEXT = 6
	CONST BTOGETPREVIOUS = 7
	CONST BTOGETGREATER = 8
	CONST BTOGETGREATEROREQUAL = 9
	CONST BTOGETLESSTHAN = 10
	CONST BTOGETLESSTHANOREQUAL = 11
	CONST BTOGETFIRST = 12
	CONST BTOGETLAST = 13
	CONST BTOCREATE = 14
	CONST BTOSTAT = 15

	CONST BTOUNLOCK = 27
	CONST BTORESET = 28

	CONST BTOTRANSBEGIN = 19
	CONST BTOTRANSABORT = 21
	CONST BTOTRANSEND = 20
	
	CONST BTOSETOWNER = 29
	CONST BTOCLEAROWNER = 30

