REM     *********************************************************************
REM     * FILECMD.MOD
REM     *********************************************************************
REM     * SUB FileCmdLine
REM     *
REM     *********************************************************************
REM     * 870903: Created
REM     *--------------------------------------------------------------------
REM     * 900629: Changed for New update of STLIB7
REM     *--------------------------------------------------------------------
REM     * 910324: arg$(0) added (path\name of exe)
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'

	TYPE REGTYPEX
	     ax         AS INTEGER
	     bx         AS INTEGER
	     cx         AS INTEGER
	     dx         AS INTEGER
	     bp         AS INTEGER
	     si         AS INTEGER
	     di         AS INTEGER
	     flags      AS INTEGER
	     ds         AS INTEGER
	     es         AS INTEGER
	END TYPE

DEFINT A-Z
'       ---------------------------------------------------------------------
'        FileCmdLine: Splits command line like C main().     
'       ---------------------------------------------------------------------
	SUB FileCmdLine (arg$(), argc)
	    argc = 0
	    sCmdLine$ = COMMAND$
	    IF sCmdLine$ <> "" THEN
	       iSpaceOld = 1
	       iSpacePos = INSTR(iSpaceOld, sCmdLine$, " ")
	       IF iSpacePos = 0 THEN
		  argc = 1
		  REDIM arg$(1)
		  arg$(argc) = sCmdLine$
	       ELSE
		  iSpaceOld = 1
		  DO
		     argc = argc + 1
		     iSpace = INSTR(iSpaceOld, sCmdLine$, " ")
		     IF iSpace <> 0 THEN
			DO
			   iSpace = iSpace + 1
			   sTemp$ = MID$(sCmdLine$, iSpace, 1)
			LOOP WHILE sTemp$ <> " "
			iSpaceOld = iSpace + 1
		     ELSE
			iSpace = LEN(sCmdLine$)
			iSpace = 0
		     END IF
		  LOOP UNTIL iSpace = 0

		  REDIM arg$(argc)
		  argc = 0
		  iSpaceOld = 1
		  DO
		     argc = argc + 1
		     iSpace = INSTR(iSpaceOld, sCmdLine$, " ")
		     IF iSpace <> 0 THEN
			arg$(argc) = MID$(sCmdLine$, iSpaceOld, iSpace - iSpaceOld)
			iSpaceOld = iSpace + 1
		     ELSE
			iSpace = LEN(sCmdLine$)
			arg$(argc) = RIGHT$(sCmdLine$, iSpace - iSpaceOld + 1)
			iSpace = 0
		     END IF
		  LOOP UNTIL iSpace = 0
	       END IF
	    ELSE
	       REDIM arg$(0)
	    END IF

	    DIM reg AS REGTYPEX
	    reg.ax = 25088
	    CALL InterruptX(&H21, reg, reg)

	    DEF SEG = reg.bx
	    envlo = PEEK(&H2C)
	    envhi = PEEK(&H2D)

	    DEF SEG = envlo + (envhi * 256)

	    pointer = 0
	    DO UNTIL PEEK(pointer) = 0
	       DO UNTIL PEEK(pointer) = 0
		  pointer = pointer + 1
	       LOOP
	       pointer = pointer + 1
	    LOOP

	    progname$ = ""

	    pointer = pointer + 3
	    DO UNTIL PEEK(pointer) = 0
	       progname$ = progname$ + CHR$(PEEK(pointer))
	       pointer = pointer + 1
	    LOOP
	    arg$(0) = progname$
	    DEF SEG

	END SUB

