DECLARE FUNCTION DosCvtAttr$ (attrib$)
REM     *********************************************************************
REM     * DOSCVTAT.MOD
REM     *********************************************************************
REM     * FUNCTION DosCvtAttr$
REM     *
REM     *********************************************************************
REM     * 890328: Created
REM     *--------------------------------------------------------------------
REM     * 900629: Changed for New update of STLIB7
REM     *********************************************************************
	REM $INCLUDE: 'STLIB.BI'

DEFINT A-Z
'       ---------------------------------------------------------------------
'        DosCvtAttr: Converts dirattrib to HSRA string.               890328
'       ---------------------------------------------------------------------
	FUNCTION DosCvtAttr$ (attrib$) STATIC
	    temp$ = "...."
	    attrib = ASC(attrib$)
	    IF (attrib AND 2) = 2 THEN
	       MID$(temp$, 1, 1) = "H"
	    END IF
	    IF (attrib AND 4) = 4 THEN
	       MID$(temp$, 2, 1) = "S"
	    END IF
	    IF (attrib AND 1) = 1 THEN
	       MID$(temp$, 3, 1) = "R"
	    END IF
	    IF (attrib AND 32) = 32 THEN
	       MID$(temp$, 4, 1) = "A"
	    END IF
	    DosCvtAttr$ = temp$
	END FUNCTION

DEFSNG A-Z
DEFINT A-Z
'       ---------------------------------------------------------------------
'        DosCvtTime: Converts dirtime to HH:MM.SS string.          
'       ---------------------------------------------------------------------
	SUB DosCvtTime (tid, tid$)
	    hour = INT(tid \ 2048)
	    rest = tid - (hour * 2048)
	    minut = INT(rest \ 32)
	    rest = rest - (minut * 32)
	    sek = rest * 2
	    IF hour < 0 THEN
	       hour = 32 + hour
	    END IF
	    hour = ABS(hour)
	    minut = ABS(minut)
	    sek = ABS(sek)
	    h$ = STRING$(2 - LEN(LTRIM$(STR$(hour))), "0") + LTRIM$(STR$(hour))
	    min$ = STRING$(2 - LEN(LTRIM$(STR$(minut))), "0") + LTRIM$(STR$(minut))
	    s$ = STRING$(2 - LEN(LTRIM$(STR$(sek))), "0") + LTRIM$(STR$(sek))
	    tid$ = h$ + ":" + min$ + ":" + s$
	END SUB

