REM     *********************************************************************
REM     * DOSCFG.MOD
REM     *********************************************************************
REM     * SUB DosConfig
REM     *
REM     *********************************************************************
REM     * 910324: Created
REM     *********************************************************************
	REM $INCLUDE: 'STLIB.BI'

DEFINT A-Z
'       ---------------------------------------------------------------------
'        DosConfig:
'       ---------------------------------------------------------------------
	SUB DosConfig (conf AS CONFIGTYPE)
	    DIM reg AS REGTYPE
	    CALL Interrupt(&H11, reg, reg)

	    conf.mathco = (reg.ax AND 2) \ 2
	    conf.printers = (reg.ax AND &HC000&) \ 16384
	    conf.serials = (reg.ax AND &HE00) \ 512
	    conf.games = (reg.ax AND &H1000) \ 4096

	    conf.processor = DosQueryIntel

	    CALL Interrupt(&H12, reg, reg)
	    conf.totalmem = reg.ax

	    DEF SEG = &H40
	    drv = PEEK(&H10)
	    IF (drv AND 64) = 64 THEN
	       conf.isdrvb = TRUE
	    ELSE
	       conf.isdrvb = FALSE
	    END IF
	    DEF SEG
	END SUB

