REM     *********************************************************************
REM     * HELP.MOD
REM     *********************************************************************
REM     * SUB Help
REM     *
REM     *********************************************************************
REM     * 901001: Created
REM     *--------------------------------------------------------------------
REM     * 901230: Inserted into STLIB7
REM     *--------------------------------------------------------------------
REM     * 930419: Changed for new color settings
REM     *********************************************************************
	REM $INCLUDE: 'STLIB.BI'

	TYPE HELPTYPE
	     htext      AS STRING * 25
	     hpos       AS LONG
	END TYPE

	REM $DYNAMIC

	DEFINT A-Z

	DIM SHARED hfile$, hitem(200) AS HELPTYPE, htext$(200)

REM $STATIC
'       ---------------------------------------------------------------------
'        Help: Gets help text from help file and uses TextView.       930419
'       ---------------------------------------------------------------------
	SUB Help (item)
	    IF hitem(item).hpos < 1 THEN
	       nul = MessageBox(0, IDSHELP, "", "HJLPTEXT EJ FUNNEN !", "")
	       EXIT SUB
	    END IF
	    REDIM htext$(200)
	    memo$ = MemoGet$(hfile$, hitem(item).hpos)
	    lines = MemoM2A(memo$, htext$())
	    vio$ = VioSpace$(5, 13, 21, 68)
	    CALL VioGetWindow(5, 13, 21, 68, vio$)
	    CALL VioShade(5, 13, 21, 68)
	    CALL VioFrame(5, 13, 20, 66, VioColor(st.bfcolor, st.wbcolor), 32)
	    temp$ = " HJLP: " + StrTrim$(hitem(item).htext) + " "
	    vioclr = VioColor(st.bbcolor, st.bfcolor)
	    CALL VioCPrint(5, 13, vioclr, SPACE$(54))
	    CALL VioCPrint(5, StrCenter(10, 71, temp$), vioclr, temp$)
	    CALL VioCPrint(20, 13, vioclr, SPACE$(54))
	    CALL VioPrint(20, 27, "Tryck ESC fr att fortstta")
	    DIM imle AS MLETYPE
	    imle.row1 = 6
	    imle.col1 = 14
	    imle.row2 = 19
	    imle.col2 = 65
	    imle.frame = FALSE
	    imle.rcol = 50
	    nul = TextView(htext$(), 0, imle)
	    DO
	       scan = TextView(htext$(), 1, imle)
	    LOOP WHILE scan <> KEYESC
	    nul = TextView(htext$(), 2, imle)
	    CALL VioPutWindow(5, 13, 21, 68, vio$)
	END SUB

'       ---------------------------------------------------------------------
'        HelpFile:
'       ---------------------------------------------------------------------
	FUNCTION HelpFile (helpname$)
	    REDIM hitem(200) AS HELPTYPE
	    IF INSTR(helpname$, ".") = FALSE THEN
	       hfile$ = helpname$ + ".HLP"
	    ELSE
	       hfile$ = helpname$
	    END IF
	    IF DosQFile(hfile$ + CHR$(0), IDFOPEN) = TRUE THEN
	       htemp = FREEFILE
	       OPEN hfile$ FOR BINARY AS #htemp
		    FOR counter = 1 TO 200
			GET #htemp, , hitem(counter)
		    NEXT
	       CLOSE #htemp
	       HelpFile = TRUE
	    ELSE
	       HelpFile = FALSE
	    END IF
	END FUNCTION

