DECLARE FUNCTION ExeName$
DECLARE SUB Line25 (flag%)
DECLARE SUB HelpText (place%, rub$)
DECLARE FUNCTION RubrikChg% (flag%, rub$)
REM     ********************************************************************
REM     *
REM     *
REM     *
REM     *
REM     *
REM     ********************************************************************
	' $INCLUDE: 'STLIB.BI'

	TYPE HELPTYPE
	     htext      AS STRING * 25
	     hpos       AS LONG
	END TYPE

	REM $DYNAMIC

	DEFINT A-Z

	DIM SHARED hitem(200) AS HELPTYPE, htext$(200)
	DIM SHARED hfile$

	IF COMMAND$ = "" THEN
	   END
	END IF

	hfile$ = COMMAND$
	IF INSTR(hfile$, ".") = FALSE THEN
	   hfile$ = hfile$ + ".HLP"
	END IF

	IF VioQueryColor(nul) = TRUE THEN
	   st.fcolor = WHITE
	   st.bcolor = BLUE
	   st.scolor = BROWN
	ELSE
	   st.fcolor = MONOON
	   st.bcolor = MONOOFF
	   st.scolor = MONOON
	END IF
	COLOR st.fcolor, st.scolor
	CLS
	COLOR st.bcolor, st.fcolor
	LOCATE 1, 1
	PRINT SPACE$(80);
	LOCATE 1, 3
	PRINT "HelpMake Version 0.10  Copyright (C) 1990, Software Technologies"; ExeName$
	CALL Line25(1)
	COLOR st.fcolor, st.bcolor
	IF DosQFile(hfile$ + CHR$(0), IDFOPEN) = FALSE THEN
	   hhelp = FREEFILE
	   OPEN hfile$ FOR BINARY AS #hhelp
		FOR counter = 1 TO 200
		    PUT #hhelp, , hitem(counter)
		NEXT counter
	   CLOSE #hhelp
	END IF

	REDIM temp$(200)
	hhelp = FREEFILE
	OPEN hfile$ FOR BINARY AS #hhelp
	     FOR counter = 1 TO 200
		 GET #hhelp, , hitem(counter)
		 temp$(counter) = RIGHT$("  " + STR$(counter), 3) + "" + RIGHT$("          " + STR$(hitem(counter).hpos), 10) + "" + hitem(counter).htext
	     NEXT counter
	CLOSE #hhelp

	quit = FALSE
	DO
	    REDIM ret(2)
	    ret(1) = KEYENTER
	    ret(2) = KEYESC
	    up = 5
	    CALL VioFrame(4, 19, 20, 60, VioColor(-1, -1), 0)
	    ret = ListBox(up, 20, 15, 40, 0, temp$(), FALSE, ret())
	    SELECT CASE ret
		   CASE KEYENTER
			IF hitem(up).hpos = 0 THEN
			   CALL Line25(2)
			   IF RubrikChg(FALSE, rub$) = TRUE THEN
			      CALL HelpText(up, rub$)
			      hitem(up).htext = rub$
			      temp$(up) = RIGHT$("  " + STR$(up), 3) + "" + RIGHT$("          " + STR$(hitem(up).hpos), 10) + "" + hitem(up).htext
			   END IF
			   CALL Line25(1)
			ELSE
			   CALL Line25(2)
			   rub$ = hitem(up).htext
			   IF RubrikChg(TRUE, rub$) = TRUE THEN
			      CALL HelpText(up, rub$)
			      hitem(up).htext = rub$
			      temp$(up) = RIGHT$("  " + STR$(up), 3) + "" + RIGHT$("          " + STR$(hitem(up).hpos), 10) + "" + hitem(up).htext
			   END IF
			   CALL Line25(1)
			END IF
		   CASE KEYESC
			quit = TRUE
		   CASE KEYDEL

		   CASE ELSE
	    END SELECT
	LOOP WHILE quit = FALSE

	CALL InfoBox(TRUE, "", "Sparar/Packar", "")

	hcopy = FREEFILE
	OPEN "TEMPDEL.HLP" FOR BINARY AS #hcopy
	     blank$ = SPACE$(5800)
	     PUT #hcopy, , blank$
	     blank$ = ""
	CLOSE #hcopy
	FOR counter = 1 TO 200
	    hitem(counter).htext = MID$(temp$(counter), 16, 25)
	    hitem(counter).hpos = VAL(MID$(temp$(counter), 5, 10))
	    IF hitem(counter).hpos > 0 THEN
	       memo$ = MemoGet$(hfile$, hitem(counter).hpos)
	       hitem(counter).hpos = MemoPut&("TEMPDEL.HLP", memo$)
	    END IF
	NEXT counter
	hcopy = FREEFILE
	OPEN "TEMPDEL.HLP" FOR BINARY AS #hcopy
	     FOR counter = 1 TO 200
		 PUT #hcopy, , hitem(counter)
	     NEXT
	CLOSE #hcopy
	nul = DosKill(hfile$ + CHR$(0))
	nul = DosMoveFile("TEMPDEL.HLP" + CHR$(0), hfile$ + CHR$(0))

	CALL InfoBox(FALSE, "", "", "")

	COLOR WHITE, BLACK
	CLS
	END

REM $STATIC
'       ---------------------------------------------------------------------
'        HelpText:
'       ---------------------------------------------------------------------
	SUB HelpText (place, rub$)
	    vio$ = VioSpace$(5, 14, 20, 67)
	    CALL VioGetWindow(5, 14, 20, 67, vio$)
	    CALL VioShade(5, 14, 20, 67)
	    IF hitem(place).hpos > 0 THEN
	       REDIM htext$(200)
	       memo$ = MemoGet$(hfile$, hitem(place).hpos)
	       nul = MemoM2A(memo$, htext$())
	    ELSE
	       REDIM htext$(200)
	    END IF
	    REDIM ret(2)
	    ret(1) = KEYF2
	    ret(2) = KEYESC
	    cwidth = 50
	    REDIM clip$(50)
	    COLOR st.bcolor, st.fcolor
	    LOCATE 5, 14: PRINT SPACE$(52);
	    temp$ = RIGHT$("  " + STR$(place), 3) + ":" + StrTrim$(rub$)
	    CALL VioPrint(5, StrCenter(14, 65, temp$), temp$)
	    COLOR st.fcolor, st.bcolor
	    ret = TextEdit(htext$(), 6, 14, 19, 65, cwidth, clip$(), TRUE, ret(), IDHNULL)
	    IF ret = KEYF2 THEN
	       CALL MemoA2M(cwidth, htext$(), memo$)
	       hitem(place).hpos = MemoPut&(hfile$, memo$)
	    END IF
	    CALL VioPutWindow(5, 14, 20, 67, vio$)
	END SUB

'       ---------------------------------------------------------------------
'        Line25:
'       ---------------------------------------------------------------------
	SUB Line25 (flag)
	    COLOR st.bcolor, st.fcolor
	    LOCATE 25, 1: PRINT SPACE$(80);
	    SELECT CASE flag
		   CASE 1
			LOCATE 25, 3: PRINT "Enter=ndra  Esc=Avsluta";
		   CASE 2
			LOCATE 25, 3: PRINT "F2=Spara  Esc=Avbryt";
		   CASE ELSE
	    END SELECT
	    COLOR st.fcolor, st.bcolor
	END SUB

'       ---------------------------------------------------------------------
'        RubrikChg:
'       ---------------------------------------------------------------------
	FUNCTION RubrikChg (flag, rub$)
	    vio$ = VioSpace$(9, 24, 17, 59)
	    CALL VioGetWindow(9, 24, 17, 59, vio$)
	    CALL VioShade(9, 24, 17, 59)
	    CALL VioFrame(9, 24, 16, 57, VioColor(-1, -1), 32)
	    CALL VioPrint(9, 25, "Ŀ")
	    IF flag = FALSE THEN
	       CALL VioPrint(10, 25, "  ***   ANGE NY RUBRIK   ***  ")
	    ELSE
	       CALL VioPrint(10, 25, "  ***   NDRING RUBRIK   ***  ")
	    END IF
	    CALL VioPrint(11, 25, "                              ")
	    CALL VioPrint(12, 25, "                              ")
	    CALL VioPrint(13, 25, "                              ")
	    CALL VioPrint(14, 25, "Ĵ")
	    CALL VioPrint(15, 25, "   Enter=Spara   Esc=avbryt   ")
	    CALL VioPrint(16, 25, "")
	    vioclr = VioColor(st.bcolor, st.fcolor)
	    CALL VioCPrint(12, 28, vioclr, StrFormat$(IDSFSTR, SPACE$(25), rub$))
	    REDIM ret(2)
	    ret(1) = KEYENTER
	    ret(2) = KEYESC
	    COLOR st.bcolor, st.fcolor
	    ret = EditString(rub$, 12, 28, 25, ret(), IDHUCASE)
	    COLOR st.fcolor, st.bcolor
	    SELECT CASE ret
		   CASE KEYENTER
			IF StrTrim$(rub$) <> "" THEN
			   RubrikChg = TRUE
			   quit = TRUE
			END IF
		   CASE KEYESC
			RubrikChg = FALSE
			quit = TRUE
		   CASE ELSE
	    END SELECT
	    CALL VioPutWindow(9, 24, 17, 59, vio$)
	END FUNCTION

