'       ---------------------------------------------------------------------
'        STX.BI: Definition file.                                    910324
'       ---------------------------------------------------------------------

REM     ****** DosConfig constants ******
	CONST IDP8086 = 0
	CONST IDP80186 = 1
	CONST IDP80286 = 2
	CONST IDP80386 = 3
	CONST IDP80486 = 4

	TYPE MDBLISTTYPE
	     row1       AS INTEGER
	     col1       AS INTEGER
	     row2       AS INTEGER
	     col2       AS INTEGER
	     handle     AS INTEGER
	     frame      AS INTEGER
	END TYPE

	TYPE CONFIGTYPE
	     processor  AS INTEGER
	     mathco     AS INTEGER
	     totalmem   AS INTEGER
	     printers   AS INTEGER
	     serials    AS INTEGER
	     games      AS INTEGER
	     isdrvb     AS INTEGER
	END TYPE

'       ---------------------------------------------------------------------
'        Declaration of procedures and functions in STX.LIB (ASM) etc.
'       ---------------------------------------------------------------------
	DECLARE SUB KbdExtBuffer (flag%)

	DECLARE FUNCTION DosQueryIntel%

	DECLARE FUNCTION DosDiskRedir% (drv%)

	DECLARE FUNCTION DiskReset% (drive%)
	DECLARE FUNCTION DiskReadSector% (drv%, head%, trck%, ssec%, slen%, sdata$)
	DECLARE FUNCTION DiskVerifySector% (drv%, head%, trck%, ssec%, slen%, sdata$)
	DECLARE FUNCTION DiskWriteSector% (drv%, head%, trck%, ssec%, slen%, sdata$)
	DECLARE FUNCTION DiskSetMedia% (drv%, trck%, sect%)
	DECLARE FUNCTION DiskFormatTrack% (drv%, head%, trck%, ftab$)
	DECLARE SUB DiskGetDPT (item%, value%)
	DECLARE SUB DiskPutDPT (item%, value%)

	DECLARE FUNCTION DosCvtAttr$ (attrib$)
	DECLARE SUB DosCvtTime (time%, dtime8$)
	DECLARE SUB DosCvtDate (date%, ddate8$)

	DECLARE FUNCTION FileFind% (file$(), path$)
	DECLARE FUNCTION FileBoxOpen% (wild$, path$, file$)

	DECLARE FUNCTION FileBoxSaveAs% (file$, ext$, path$)

	DECLARE SUB SortIntArray (inte%(), low%, high%)

	DECLARE FUNCTION MDBList% (mdbfunc%, ml AS MDBLISTTYPE, record$)

	DECLARE SUB StrCrypt (flag%, strn$)

	DECLARE FUNCTION MaxI% (int1%, int2%)
	DECLARE FUNCTION MinI% (int1%, int2%)
	DECLARE FUNCTION BitGet% (value&, bit%)
	DECLARE SUB BitSet (value&, bit%, newval%)

