DECLARE FUNCTION StrCenter% (x1%, x2%, s$)
REM     *********************************************************************
REM     * WMSGBOX.MOD
REM     *********************************************************************
REM     * Part of WIN.MOD library after split
REM     *
REM     *********************************************************************
REM     * 931107: Split...
REM     *--------------------------------------------------------------------
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'
	DEFINT A-Z

'       ---------------------------------------------------------------------
'        WinMessageBox:
'       ---------------------------------------------------------------------
	FUNCTION WinMessageBox (iBoxType, sRubrik$, sRad1$, sRad2$, sRad3$)
	    IF sRubrik$ = "" THEN
	       sRubrik$ = "INFORMATION"
	    END IF

	    CALL QueryDefault(dShade, dZoom, dFrame, fZoomTime!, bf, bb, wf, wb, ff, fb, ef, eb)

	    DIM hwnd AS WINDOWTYPE

	    sVio$ = WinOpenWindow(hwnd, 9, 20, 7, 40, sRubrik$, -1, -1, -1)

	    CALL WinPrint(hwnd, 2, StrCenter(2, 38, sRad1$), sRad1$)
	    CALL WinPrint(hwnd, 3, StrCenter(3, 38, sRad2$), sRad2$)
	    CALL WinPrint(hwnd, 4, StrCenter(4, 38, sRad3$), sRad3$)
	    SELECT CASE iBoxType
		   CASE 0
			CALL WinColorPrint(hwnd, 6, 16, ef, eb, " < Ok > ")
			LOCATE hwnd.iRow1 + 6, hwnd.iCol1 + 19, 1
			quit = FALSE
			DO
			   CALL KbdInkey(IDKWAIT, iScan, iShift)
			   SELECT CASE iScan
				  CASE KEYENTER, KEYSPACE
				       quit = TRUE
				  CASE ELSE
			   END SELECT
			LOOP WHILE quit = FALSE
			WinMessageBox = 0
		   CASE 1
			CALL WinColorPrint(hwnd, 6, 10, ef, eb, " < Ja > ")
			CALL WinColorPrint(hwnd, 6, 22, ef, eb, " < Nej > ")

			quit = FALSE
			iFieldId = 0
			DO
			   IF iFieldId = 0 THEN
			      LOCATE hwnd.iRow1 + 6, hwnd.iCol1 + 13, 1
			   ELSE
			      LOCATE hwnd.iRow1 + 6, hwnd.iCol1 + 25, 1
			   END IF
			   CALL KbdInkey(IDKWAIT, iScan, iShift)
			   SELECT CASE iScan
				  CASE KEYENTER, KEYSPACE
				       quit = TRUE
				  CASE KEYRARROW, ASC("N"), ASC("n")
				       iFieldId = 1
				  CASE KEYLARROW, ASC("J"), ASC("j")
				       iFieldId = 0
				  CASE KEYTAB
				       IF iFieldId = 0 THEN
					  iFieldId = 1
				       ELSE
					  iFieldId = 0
				       END IF
				  CASE ELSE
			   END SELECT
			LOOP WHILE quit = FALSE
			IF iFieldId = 1 THEN
			   WinMessageBox = FALSE
			ELSE
			   WinMessageBox = TRUE
			END IF
		   CASE 2
			CALL WinColorPrint(hwnd, 6, 10, ef, eb, " < Nej > ")
			CALL WinColorPrint(hwnd, 6, 22, ef, eb, " < Ja > ")
		   
			quit = FALSE
			iFieldId = 0
			DO
			   IF iFieldId = 0 THEN
			      LOCATE hwnd.iRow1 + 6, hwnd.iCol1 + 13, 1
			   ELSE
			      LOCATE hwnd.iRow1 + 6, hwnd.iCol1 + 25, 1
			   END IF
			   CALL KbdInkey(IDKWAIT, iScan, iShift)
			   SELECT CASE iScan
				  CASE KEYENTER, KEYSPACE
				       quit = TRUE
				  CASE KEYRARROW, ASC("N"), ASC("n")
				       iFieldId = 0
				  CASE KEYLARROW, ASC("J"), ASC("j")
				       iFieldId = 1
				  CASE KEYTAB
				       IF iFieldId = 0 THEN
					  iFieldId = 1
				       ELSE
					  iFieldId = 0
				       END IF
				  CASE ELSE
			   END SELECT
			LOOP WHILE quit = FALSE
			IF iFieldId = 1 THEN
			   WinMessageBox = TRUE
			ELSE
			   WinMessageBox = FALSE
			END IF
		   CASE ELSE
	    END SELECT
	    LOCATE , , 0
	    CALL WinCloseWindow(hwnd, sVio$)
	END FUNCTION

