	Name    CLUSTER

	Public  SysQCluster

	Title   CLUSTER.ASM

;***************************************************************************
;       SysQCluster             ver. 0.10
;       created: 890803         Updated: 890803         Timelog: 4h
;
;       This program gets the cluster position of a file
;
;       clpos=SysQCluster (filename$)
;            string     filename$ (file to check)
;            int        clpos     (starting clusterpos of file,0 if fnf)
;***************************************************************************


;***************************************************************************
;       Data Area
;***************************************************************************

	data    segment word    public  'data'

	fbuf    db   7 dup (?)          ;dta
		db         (?)
		db 19h dup (?)
	cluster dw         (?)
		db  75 dup (?)

	fcb     db      0ffh
		db   5 dup (?)
		db      16h
		db      00h
	fname   db  11 dup (?)
		db  12 dup (?)
		dw         (?)
		db  11 dup (?)

	data    ends

	dgroup   group   data

;***************************************************************************
;       Code Area
;***************************************************************************

	code    segment byte    public  'code'
		assume  cs:code,ds:dgroup

	SysQCluster     proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		mov     ah,1ah                  ;Set DTA adress
		mov     dx,offset dgroup:fbuf
		int     21h
		mov     bx,[bp+06]
		mov     dx,[bx+02]              ;path name,
		push    ds
		pop     es
		mov     si,dx                   ;copy filename to
		mov     di,offset dgroup:fname  ;fcb
		mov     cx,11
		cld
		repz    movsb
		xor     cl,cl
		mov     dx,offset dgroup:fcb    ;call find first
		mov     ah,11h                  ;with FCB
		int     21h
		cmp     al,0
		jnz     fs_err                 ;not found
fs_ok:          mov     ax,cluster
		jmp     short fs_exit
fs_err:         xor     ax,ax
fs_exit:        pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     2                       ;return 2xParameters
	SysQCluster     endp

	code    ends
		end
