	Name    EXTBUFF

	Public  ExtBuffer

	Title   EXTBUFF.ASM
;***************************************************************************
;       FAR VERSION OF MODULE                                        900311
;***************************************************************************

;***************************************************************************
;       Data Area
;***************************************************************************

	data    segment word    public  'data'

	b_head  dw      ?               ;keyboard buffer info
	b_tail  dw      ?
	b_start dw      ?
	b_end   dw      ?
	b_flag  db      ?               ;is bufferredirected
	s_start dw      ?
	s_end   dw      ?

	data    ends
	dgroup  group   data


;***************************************************************************
;       Code Area
;***************************************************************************

	code    segment byte    public  'code'
		assume  cs:code,ds:dgroup


;---------------------------------------------------------------------------
; ExtBuffer
;---------------------------------------------------------------------------
	ExtBuffer       proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		push    ds
		push    es

		mov     bx,[bp+06]              ;TRUE or FALSE
		mov     ah,[bx]
		cmp     ah,0                    ;FALSE =
		jnz     restore_buff            ;restore buffer
		cmp     b_flag,0                ;is buffer redir
		jnz     exit_buff               ;YES = exit
		mov     ax,0040h
		push    ax
		pop     es
		mov     ax,es:[001ah]
		mov     b_head,ax               ;save old pointers
		mov     ax,es:[001ch]
		mov     b_tail,ax
		mov     ax,es:[0080h]
		mov     b_start,ax
		mov     ax,es:[0082h]
		mov     b_end,ax
		mov     b_flag,1

		cli
		mov     word ptr es:[001ah],0200h
		mov     word ptr es:[001ch],0200h
		mov     word ptr es:[0080h],0200h
		mov     word ptr es:[0082h],0300h
		sti
		jmp     short exit_buff

restore_buff:   cmp     b_flag,0                ;is buffer redir
		jz      exit_buff               ;YES = exit
		mov     ax,0040h
		push    ax
		pop     es
		mov     b_flag,0
		cli
		mov     ax,b_head
		mov     es:[001ah],ax           ;save old pointers
		mov     ax,b_tail
		mov     es:[001ch],ax
		mov     ax,b_start
		mov     es:[0080h],ax
		mov     ax,b_end
		mov     es:[0082h],ax
		sti

exit_buff:      pop     es
		pop     ds
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     02                      ;return 2xParameters
	ExtBuffer       endp

	code    ends
		end
