REM     *********************************************************************
REM     * KBDSTUFF.MOD
REM     *********************************************************************
REM     * SUB KbdStuff
REM     *
REM     *********************************************************************
REM     * 900629: Changed for New update of STLIB7
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'

DEFINT A-Z
'       ---------------------------------------------------------------------
'        KeyStuff:
'       ---------------------------------------------------------------------
	SUB KbdStuff (flag%, keypress$)
	    DEF SEG = &H40
	    bufs = PEEK(&H80) + (PEEK(&H81) * 256)
	    bufe = PEEK(&H82) + (PEEK(&H83) * 256)
	    bufh = PEEK(&H1A) + (PEEK(&H1B) * 256)
	    buft = PEEK(&H1C) + (PEEK(&H1D) * 256)
	    buflen = bufe - bufs - 2
	    SELECT CASE flag%
		   CASE 1
			work$ = LEFT$(keypress$, buflen \ 2)
			length = LEN(work$)

			lword = bufs AND 255
			hword = bufs \ 256
			POKE &H1A, lword
			POKE &H1B, hword

			temp = bufs + (length * 2)
			lword = temp AND 255
			hword = temp \ 256
			POKE &H1C, lword
			POKE &H1D, hword

			FOR counter = 0 TO length - 1
			    POKE bufs + counter * 2, ASC(MID$(work$, counter + 1))
			NEXT counter
		   CASE 2
			work$ = LEFT$(keypress$, buflen \ 2)
			length = LEN(work$)

			lword = bufs AND 255
			hword = bufs \ 256
			POKE &H1A, lword
			POKE &H1B, hword

			temp = bufs + (length * 2)
			lword = temp AND 255
			hword = temp \ 256
			POKE &H1C, lword
			POKE &H1D, hword

			FOR counter = 0 TO length - 1
			    POKE bufs + counter * 2, 0
			    POKE bufs + 1 + counter * 2, ASC(MID$(work$, counter + 1))
			NEXT counter
		   CASE 3
			work$ = LEFT$(keypress$, buflen)
			length = LEN(work$)

			lword = bufs AND 255
			hword = bufs \ 256
			POKE &H1A, lword
			POKE &H1B, hword

			temp = bufs + length
			lword = temp AND 255
			hword = temp \ 256
			POKE &H1C, lword
			POKE &H1D, hword

			FOR counter = 0 TO length - 1
			    POKE bufs + counter, ASC(MID$(work$, counter + 1))
			NEXT counter
		   CASE ELSE
	    END SELECT
	    DEF SEG
	END SUB

