REM     *********************************************************************
REM     * MENUPULL.MOD
REM     *********************************************************************
REM     * FUNCTION MenuPullDown%
REM     *
REM     *********************************************************************
REM     * 870528: Created
REM     *--------------------------------------------------------------------
REM     * 900629: Changed for New update of STLIB7
REM     *--------------------------------------------------------------------
REM     * 900701: Shadow added for color displays
REM     *--------------------------------------------------------------------
REM     * 921127: Mouse support removed
REM     *********************************************************************
	REM $INCLUDE: 'STLIB.BI'

DEFINT A-Z
'       ---------------------------------------------------------------------
'        MenuPullDown: Pull down menu.                                900103
'       ---------------------------------------------------------------------
	FUNCTION MenuPullDown (pull$(), short$, col)
	    choice = 1
	    lastrow = UBOUND(pull$)
	    REDIM pullinfo(lastrow)
	    tempone = 0
	    columns = 0
	    FOR counter = 1 TO lastrow
		IF pull$(counter) = "" THEN
		   pullinfo(counter) = 0
		ELSE
		   tempone = tempone + 1
		   pullinfo(counter) = tempone
		END IF
		temp = LEN(pull$(counter))
		IF temp > columns THEN
		   columns = temp
		END IF
	    NEXT counter
	    temp$ = VioSpace(2, col, lastrow + 4, col + columns + 5)
	    CALL VioGetWindow(2, col, lastrow + 4, col + columns + 5, temp$)
	    CALL VioShade(2, col, lastrow + 4, col + columns + 5)
	    COLOR st.wfcolor, st.wbcolor
	    FOR counter = 2 TO lastrow + 3
		LOCATE counter, col
		PRINT SPACE$(columns + 4);
	    NEXT counter
	    CALL VioPrint(2, col, "" + STRING$(columns, "") + "Ŀ")
	    FOR counter = 1 TO lastrow
		temp = counter + 2
		IF pullinfo(counter) = 0 THEN
		   CALL VioPrint(temp, col, "" + STRING$(columns, "") + "Ĵ")
		ELSE
		   pull$(counter) = " " + pull$(counter) + SPACE$(columns - LEN(pull$(counter))) + " "
		   CALL VioPrint(temp, col, "" + pull$(counter) + "")
		   IF pullinfo(counter) = choice THEN
		      COLOR st.wbcolor, st.wfcolor
		      LOCATE temp, col + 1
		      PRINT pull$(counter);
		      COLOR st.wfcolor, st.wbcolor
		   END IF
		END IF
	     NEXT counter
	     CALL VioPrint(temp + 1, col, "" + STRING$(columns, "") + "")

	     WHILE keycode <> KEYENTER AND keycode <> KEYESC AND choice > -1
		   CALL KbdInkey(IDKWAIT, keycode, shift)
		   SELECT CASE keycode
			  CASE IS > 32
			       getkey$ = UCASE$(CHR$(keycode))
			       IF getkey$ = "" THEN getkey$ = ""
			       IF getkey$ = "" THEN getkey$ = ""
			       IF getkey$ = "" THEN getkey$ = ""
			       FOR counter = 1 TO LEN(short$)
				   IF getkey$ = MID$(short$, counter, 1) THEN
				      choice = counter
				   END IF
			       NEXT counter
			  CASE KEYDARROW
			       choice = choice + 1
			       IF choice > LEN(short$) THEN choice = 1
			  CASE KEYUARROW
			       choice = choice - 1
			       IF choice < 1 THEN choice = LEN(short$)
			  CASE KEYLARROW
			       choice = -1
			  CASE KEYRARROW
			       choice = -2
			  CASE ELSE
		   END SELECT
		   COLOR st.wfcolor, st.wbcolor
		   FOR counter = 1 TO lastrow
		       temp = counter + 2
		       LOCATE temp, col + 1
		       IF choice = pullinfo(counter) THEN
			  COLOR st.wbcolor, st.wfcolor
			  PRINT pull$(counter)
			  COLOR st.wfcolor, st.wbcolor
		       ELSE
			  PRINT pull$(counter);
		       END IF
		   NEXT counter
	     WEND
	     CALL VioPutWindow(2, col, lastrow + 4, col + columns + 5, temp$)
	     temp$ = ""
	     IF keycode = KEYESC THEN
		choice = 0
	     END IF
	     MenuPullDown = choice
	END FUNCTION

