REM     *********************************************************************
REM     * MINMAX.MOD
REM     *********************************************************************
REM     * FUNCTION MaxI%
REM     * FUNCTION MinI%
REM     * FUNCTION BitGet%
REM     * SUB BitSet
REM     *
REM     *********************************************************************
	REM $INCLUDE: 'STLIB.BI'

DEFINT A-Z
'       ---------------------------------------------------------------------
'        BitGet:
'       ---------------------------------------------------------------------
	FUNCTION BitGet (value&, bit)
	    bitval& = 2 ^ bit
	    IF (value& AND bitval&) = bitval& THEN
	       BitGet = TRUE
	    ELSE
	       BitGet = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BitSet:
'       ---------------------------------------------------------------------
	SUB BitSet (value&, bit, newval)
	    IF newval = TRUE THEN
	       value& = value& OR (2 ^ bit)
	    ELSE
	       value& = value& XOR (2 ^ bit)
	    END IF
	END SUB

'       ---------------------------------------------------------------------
'        MaxI: Returns largest number.
'       ---------------------------------------------------------------------
	FUNCTION MaxI (val1, val2)
	    IF val1 > val2 THEN
	       MaxI = val1
	    ELSE
	       MaxI = val2
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        MinI: Returns smallest number.
'       ---------------------------------------------------------------------
	FUNCTION MinI (val1, val2)
	    IF val1 > val2 THEN
	       MinI = val2
	    ELSE
	       MinI = val1
	    END IF
	END FUNCTION

