'       ---------------------------------------------------------------------
'        STLIB.BI: Definition file for constants and subprograms.    931107
'       ---------------------------------------------------------------------
REM     ****** BOOL constants ******
	CONST FALSE = 0, TRUE = 1

REM     ****** Keyboard constants ******
	CONST IDKWAIT = 0, IDKNOWAIT = 1
	CONST IDKASCII = 1
	CONST IDKSCAN = 2
	CONST IDKBOTH = 3

REM     ****** DosQFile functions constants ******
	CONST IDFCREATE = 0, IDFOPEN = 1

REM     ****** File attribute values ******
	CONST IDFANORMAL = 0
	CONST IDFAREADONLY = 1
	CONST IDFAHIDDEN = 2
	CONST IDFASYSTEM = 4
	CONST IDFAVOLUME = 8
	CONST IDFADIRECTORY = 16
	CONST IDFAARCHIVE = 32
	CONST IDFAFILE = IDFANORMAL + IDFAREADONLY + IDFAHIDDEN + IDFASYSTEM + IDFAARCHIVE

REM     ****** Hook's for EditString/ListBox ******
	CONST IDHNULL = 0
	CONST IDHUCASE = -32768
	CONST IDHDATE = -32767
	CONST IDHTIME = -32766
	CONST IDHNUM = -32765
	CONST IDHFILE = -32764
	CONST IDHPSW = -32763

REM     ****** Functions for StrFormat ******
	CONST IDSFSTR = 0
	CONST IDSFINT = -32768
	CONST IDSFDBL = -32767
	CONST IDSFDATE = -32766
	CONST IDSFTIME = -32765
	CONST IDSFDROP = -32764
	CONST IDSFBOOL = -32763
	CONST IDSFCHK = -32762
	CONST IDSFOPT = -32761

REM     ****** Keypress constants ******
	CONST KEYENTER = 13, KEYESC = 27, KEYTAB = 9
	CONST KEYBTAB = -15, KEYBKSP = 8
	CONST KEYSPACE = 32

	CONST KEYINS = -82, KEYDEL = -83

	CONST KEYHOME = -71, KEYEND = -79, KEYPAGEUP = -73, KEYPAGEDN = -81
	CONST KEYUARROW = -72, KEYDARROW = -80, KEYLARROW = -75
	CONST KEYRARROW = -77

	CONST KEYCTRLHOME = -119, KEYCTRLEND = -117, KEYCTRLPGUP = -132
	CONST KEYCTRLPGDN = -118, KEYCTRLLARROW = -115, KEYCTRLRARROW = -116

	CONST KEYALTA = -30, KEYALTB = -48, KEYALTC = -46, KEYALTD = -32
	CONST KEYALTE = -18, KEYALTF = -33, KEYALTG = -34, KEYALTH = -35
	CONST KEYALTI = -23, KEYALTJ = -36, KEYALTK = -37, KEYALTL = -38
	CONST KEYALTM = -50, KEYALTN = -49, KEYALTO = -24, KEYALTP = -25
	CONST KEYALTQ = -16, KEYALTR = -19, KEYALTS = -31, KEYALTT = -20
	CONST KEYALTU = -22, KEYALTV = -47, KEYALTW = -17, KEYALTX = -45
	CONST KEYALTY = -21, KEYALTZ = -44

	CONST KEYALT0 = -129, KEYALT1 = -120, KEYALT2 = -121, KEYALT3 = -122
	CONST KEYALT4 = -123, KEYALT5 = -124, KEYALT6 = -125, KEYALT7 = -126
	CONST KEYALT8 = -127, KEYALT9 = -128

	CONST KEYF1 = -59, KEYF2 = -60, KEYF3 = -61, KEYF4 = -62, KEYF5 = -63
	CONST KEYF6 = -64, KEYF7 = -65, KEYF8 = -66, KEYF9 = -67, KEYF10 = -68
	CONST KEYF11 = -133, KEYF12 = -134

	CONST KEYSHFTF1 = -84, KEYCTRLF1 = -94, KEYALTF1 = -104
	CONST KEYSHFTF2 = -85, KEYCTRLF2 = -95, KEYALTF2 = -105
	CONST KEYSHFTF3 = -86, KEYCTRLF3 = -96, KEYALTF3 = -106
	CONST KEYSHFTF4 = -87, KEYCTRLF4 = -97, KEYALTF4 = -107
	CONST KEYSHFTF5 = -88, KEYCTRLF5 = -98, KEYALTF5 = -108
	CONST KEYSHFTF6 = -89, KEYCTRLF6 = -99, KEYALTF6 = -109
	CONST KEYSHFTF7 = -90, KEYCTRLF7 = -100, KEYALTF7 = -110
	CONST KEYSHFTF8 = -91, KEYCTRLF8 = -101, KEYALTF8 = -111
	CONST KEYSHFTF9 = -92, KEYCTRLF9 = -102, KEYALTF9 = -112
	CONST KEYSHFTF10 = -93, KEYCTRLF10 = -103, KEYALTF10 = -113
	CONST KEYSHFTF11 = -135, KEYCTRLF11 = -137, KEYALTF11 = -140
	CONST KEYSHFTF12 = -136, KEYCTRLF12 = -138, KEYALTF12 = -141

REM     ****** VideoType declarations ******
	CONST IDVMONO = 0
	CONST IDVCOLOR = 1
	CONST IDVERR = -1

	CONST IDVMDA = 0
	CONST IDVCGA = 1
	CONST IDVEGA = 2
	CONST IDVPGA = 3
	CONST IDVMCGA = 4
	CONST IDVVGA = 5
	CONST IDV8514 = 6
	CONST IDVHGA = 100

REM     ****** Color declaration ******
	CONST BLACK = 0, BLUE = 1, GREEN = 2, CYAN = 3, RED = 4
	CONST MANGENTA = 5, BROWN = 6, WHITE = 7, GRAY = 8
	CONST BRBLUE = 9, BRGREEN = 10, BRCYAN = 11, BRRED = 12
	CONST PINK = 13, YELLOW = 14, BRWHITE = 15
	CONST SKIP = -1
	CONST BLINK = 16
	CONST MONOON = 1, MONOOFF = 0, MONOBLINK = 2, MONOHIGH = 3


'       ---------------------------------------------------------------------
'        Declaration of TYPE's.
'       ---------------------------------------------------------------------

	TYPE STSETTINGSTYPE
	     iGlobfcolor        AS INTEGER
	     iGlobbcolor        AS INTEGER
	     iGlowfcolor        AS INTEGER
	     iGlowbcolor        AS INTEGER
	     iGloffcolor        AS INTEGER
	     iGlofbcolor        AS INTEGER
	     iGloefcolor        AS INTEGER
	     iGloebcolor        AS INTEGER
	     iGloFrame          AS INTEGER
	     iGloShade          AS INTEGER
	     iGloZoom           AS INTEGER
	     fGloZoomTime       AS SINGLE
	     iFloatDelim        AS STRING * 1
	     iDateDelim         AS STRING * 1
	     iTimeDelim         AS STRING * 1
	     iZeroSupress       AS INTEGER
	END TYPE

	TYPE WINDOWTYPE
	     iRow1      AS INTEGER
	     iCol1      AS INTEGER
	     iRow2      AS INTEGER
	     iCol2      AS INTEGER
	     iFrame     AS INTEGER
	     iZoom      AS INTEGER
	     iShade     AS INTEGER
	     bfcolor    AS INTEGER
	     bbcolor    AS INTEGER
	     wfcolor    AS INTEGER
	     wbcolor    AS INTEGER
	     ffcolor    AS INTEGER
	     fbcolor    AS INTEGER
	     efcolor    AS INTEGER
	     ebcolor    AS INTEGER
	     oldcolor   AS STRING * 8
	END TYPE

	TYPE LISTBOXTYPE
	     row1       AS INTEGER
	     col1       AS INTEGER
	     row2       AS INTEGER
	     col2       AS INTEGER
	     startat    AS INTEGER
	     llen       AS INTEGER
	     mark       AS INTEGER
	     frame      AS INTEGER
	     curpos     AS INTEGER
	     ivio       AS INTEGER
	     nvio       AS INTEGER
	     lvisible   AS INTEGER
	     offset     AS INTEGER
	     oldoffset  AS INTEGER
	     curRow     AS INTEGER
	     redraw     AS INTEGER
	END TYPE

	TYPE DIRENTRYTYPE
	     attrib   AS STRING * 1
	     time     AS INTEGER
	     date     AS INTEGER
	     size     AS LONG
	     fname    AS STRING * 13
	END TYPE


'       ---------------------------------------------------------------------
'        Declaration of procedures and functions in STLIB
'       ---------------------------------------------------------------------
	'****  DIR_F.ASM      ****
	DECLARE FUNCTION DosQMatches% (path0$, attrib%)
	DECLARE SUB DosGetDir (dirx() AS DIRENTRYTYPE, path0$, attrib%)
	DECLARE SUB DosGetSubDir (dirx() AS ANY, path0$, antal%)
	DECLARE FUNCTION DosMakeDir% (path0$)
	DECLARE FUNCTION DosChangeDir% (path0$)
	DECLARE FUNCTION DosRemoveDir% (path0$)

	'****  FILE_F.ASM     ****
	DECLARE FUNCTION DosMoveFile% (oldpath0$, newpath0$)
	DECLARE FUNCTION DosCopyFile% (from$, to$, buff$, erfix%)
	DECLARE FUNCTION DosGetSize& (file0$)
	DECLARE FUNCTION DosKill% (file0$)
	DECLARE FUNCTION DosGetAttr% (file0$, attrib%)
	DECLARE FUNCTION DosSetAttr% (file0$, attrib%)
	DECLARE FUNCTION DosQFile% (file0$, flag%)

	'****  MOU_F.ASM   ****
	DECLARE SUB MouGetPos (row%, col%, pressed%)
	DECLARE FUNCTION MouInit% (dbltime%)
	DECLARE FUNCTION MouDown% (row%, col%)
	DECLARE SUB MouSetPos (row%, col%)
	DECLARE SUB MouShow (visible%)
	DECLARE FUNCTION KbdInt16& (flag%, keycode%, shift%, mrow%, mcol%, mclick%)
	DECLARE SUB KbdClear

	DECLARE FUNCTION TSEGADD& (typevar AS ANY)
	DECLARE SUB MemCopy (pfrom&, pto&, cLen%)

	'****  SYS_F.ASM      ****
	DECLARE SUB DosVersion (major%, minor%)
	DECLARE FUNCTION DosPrtErr% (port%)
	DECLARE FUNCTION DosSetDisk% (drive%)
	DECLARE FUNCTION DosCurDisk% ()
	DECLARE FUNCTION DosDiskValid% (drive%)
	DECLARE FUNCTION DosDiskType% (drive%)
	DECLARE FUNCTION DosDiskParam% (drive%)
	DECLARE FUNCTION DosDiskSpace% (drv%, dtot&, dfre&, alloc%)

	'****  VIO_F.ASM      ****
	DECLARE SUB VioGetWindow (row1%, col1%, row2%, col2%, buffer$)
	DECLARE SUB VioPutWindow (row1%, col1%, row2%, col2%, buffer$)
	DECLARE SUB VioFill (row%, col%, attr%, lenstr%)
	DECLARE SUB VioShade (row1%, col1%, row2%, col2%)
	DECLARE SUB VioCPrint (row%, col%, attr%, data$)
	DECLARE SUB VioPrint (row%, col%, data$)
	DECLARE SUB VioFrame (row1%, col1%, row2%, col2%, attr%, frame%)
	DECLARE FUNCTION VioQueryColor% (adapter%)
	DECLARE SUB VioQueryCurSize (urow%, lrow%)

	'****  QBX.ASM      ****
	DECLARE SUB Interrupt (intnum AS INTEGER, inreg AS ANY, outreg AS ANY)
	DECLARE SUB InterruptX (intnum AS INTEGER, inreg AS ANY, outreg AS ANY)

	'****  CMDLINE.MOD     ****
	DECLARE SUB FileCmdLine (arg$(), arg%)

	'****  DATE.MOD     ****
	DECLARE FUNCTION DateNumber% (sDay$)
	DECLARE FUNCTION NumberDate$ (iNumber%)
	DECLARE FUNCTION DayOfWeek% (sDay$)

	'****  FILEFIND.MOD     ****
	DECLARE FUNCTION FileFind% (sFileList$(), sStartPath$)

	'****  KBDINKEY.MOD     ****
	DECLARE SUB KbdInkey (flag%, keypress%, shift%)

	'****  KBDSTUFF.MOD     ****
	DECLARE SUB KbdStuff (flag%, keys$)

	'****  MEMO.MOD  ****
	DECLARE FUNCTION MemoGet$ (memofile$, mstart&)
	DECLARE FUNCTION MemoPut& (memofile$, memo$)
	DECLARE SUB MemoA2M (last%, txt$(), memo$)
	DECLARE FUNCTION MemoM2A% (memo$, txt$())
	DECLARE FUNCTION MemoLines% (memo$)

	'****  STRARRAY.MOD  ****
	DECLARE SUB StrArraySort (strn$(), low%, high%)
	DECLARE SUB StrArrayAdd (strn$(), where%, new$)
	DECLARE SUB StrArrayDel (strn$(), where%)

	'****  STRFORMA.MOD  ****
	DECLARE FUNCTION StrFormat$ (flag%, form$, strn$)

	'****  STRLAST.MOD  ****
	DECLARE FUNCTION StrLast% (start%, orgstr$, find$)
	DECLARE FUNCTION StrRight$ (strn$, position%)

	'****  STRTRIM.MOD  ****
	DECLARE FUNCTION StrTrim$ (strn$)

	'****  TIME.MOD     ****
	DECLARE FUNCTION TimeNumber% (sTime$)
	DECLARE FUNCTION NumberTime$ (iNumber%)

	'****  VIO.MOD  ****
	DECLARE FUNCTION VioColor% (f%, b%)
	DECLARE FUNCTION VioSpace$ (row1%, col1%, row2%, col2%)

	'****  WDESKTOP.MOD  ****
	DECLARE SUB WinDesktop (iFlag%, sRubrik$, iFillChar%, iStatus%)

	'****  WEDITBTN.MOD  ****
	DECLARE FUNCTION WinEditButton% (hwnd AS ANY, sText$, iRow%, iCol%, iRet%, aiRet%())

	'****  WEDITDBL.MOD  ****
	DECLARE FUNCTION WinEditDbl% (hwnd AS ANY, fValue#, iRow%, iCol%, sForm$, iRet%())

	'****  WEDITINT.MOD  ****
	DECLARE FUNCTION WinEditInt% (hwnd AS ANY, iValue%, iRow%, iCol%, sForm$, iRet%())

	'****  WEDITSTR.MOD  ****
	DECLARE FUNCTION WinEditString% (hwnd AS ANY, sText$, iRow%, iCol%, iLen%, iRet%(), iHook%)
	DECLARE FUNCTION EditString% (sText$, iRow%, iCol%, iLen%, iRet%(), iHook%)

	'****  WEDTBOOL.MOD  ****
	DECLARE FUNCTION WinEditBool% (hwnd AS ANY, iCurVal%, iRow%, iCol%, sSelect$, aiRet%())
	DECLARE FUNCTION WinEditCheck% (hwnd AS ANY, iCurVal%, iRow%, iCol%, sText$, aiRet%())
	DECLARE FUNCTION WinEditOption% (hwnd AS ANY, iCurVal%, iRow%, iCol%, sText$, aiRet%())

	'****  WEDTDATE.MOD  ****
	DECLARE FUNCTION WinEditDate% (hwnd AS ANY, sDate$, iRow%, iCol%, iRet%())

	'****  WEDTDROP.MOD  ****
	DECLARE FUNCTION WinEditDrop% (hwnd AS ANY, asDrop$(), iCurItem%, iRow%, iCol%, iLenCol%, iRet%(), iHook%)

	'****  WEDTTIME.MOD  ****
	DECLARE FUNCTION WinEditTime% (hwnd AS ANY, sTime$, iRow%, iCol%, iRet%())

	'****  WLISTBOX.MOD  ****
	DECLARE FUNCTION WinListBox% (hwnd AS ANY, li AS ANY, lbfunc%, ldata$())
	DECLARE FUNCTION ListBox% (li AS ANY, lbfunc%, ldata$())

	'****  WMAIN.MOD  ****
	DECLARE FUNCTION WinOpenWindow$ (hwnd AS ANY, iRow1%, iCol1%, iRowLen%, iColLen%, sRubrik$, iShade%, iZoom%, iFrame%)
	DECLARE SUB WinCloseWindow (hwnd AS ANY, sVio$)
	DECLARE SUB WinSetDefault (iShade%, iZoom%, iFrame%, fZoomTime!, bf%, bb%, wf%, wb%, ff%, fb%, ef%, eb%)

	DECLARE SUB QueryDefault (iShade%, iZoom%, iFrame%, fZoomTime!, bf%, bb%, wf%, wb%, ff%, fb%, ef%, eb%)
	DECLARE SUB SetColor (hwnd AS ANY)
	DECLARE SUB ValidPos (hwnd AS ANY, iRow%, iCol%, iLen%)
	DECLARE FUNCTION StrCenter% (x1%, x2%, s$)

	'****  WMENUC.MOD  ****
	DECLARE FUNCTION WinMenuChoice% (hwnd AS ANY, iFlag%, iRow%, iCol%, sRubrik$, menu$(), li AS ANY)

	'****  WMSGBOX.MOD  ****
	DECLARE FUNCTION WinMessageBox% (boxtype%, sRubrik$, two$, three$, four$)

	'****  WPERBOX.MOD  ****
	DECLARE SUB WinPercentBox (hwnd AS ANY, iFlag%, sRubrik$, iRow%, iCol%, iStart%, iStop%)

	'****  WPRINT.MOD  ****
	DECLARE SUB WinColorPrint (hwnd AS ANY, iRow%, iCol%, fc%, bc%, sText$)
	DECLARE SUB WinEditPrint (hwnd AS ANY, iRow%, iCol%, sText$)
	DECLARE SUB WinFieldPrint (hwnd AS ANY, iRow%, iCol%, sText$)
	DECLARE SUB WinFrame (hwnd AS ANY, sTitle$, iRow1%, iCol1%, iRowTo%, iColTo%, iLineTo%)
	DECLARE SUB WinPrint (hwnd AS ANY, iRow%, iCol%, sText$)
	DECLARE SUB WinStatusPrint (iCol%, iField%, sText$)

'       ---------------------------------------------------------------------
'        Declaration of global common shared variables.
'       ---------------------------------------------------------------------
	COMMON SHARED /STLIB/ st AS STSETTINGSTYPE

