REM     *********************************************************************
REM     * TIME.MOD
REM     *********************************************************************
REM     * FUNCTIONs
REM     *
REM     *********************************************************************
REM     * 901001: Created
REM     *********************************************************************
REM     * 931105: Split (DATE/TIME) and name changes.
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'
	DEFINT A-Z

'       ---------------------------------------------------------------------
'        TimeNumber: Converts time to Serial number.
'       ---------------------------------------------------------------------
	FUNCTION TimeNumber (sTid$)
	    iHour = VAL(LEFT$(sTid$, 2))
	    iMinute = VAL(RIGHT$(sTid$, 2))
	    TimeNumber = iMinute + (iHour * 60)
	END FUNCTION

'       ---------------------------------------------------------------------
'        NumberTime: Converts (serial)time to timestring.
'       ---------------------------------------------------------------------
	FUNCTION NumberTime$ (iTime)
	    iHour = (iTime \ 60)
	    iMinute = iTime - ((iTime \ 60) * 60)

	    sTmp1$ = RIGHT$("0" + LTRIM$(STR$(iHour)), 2)
	    sTmp2$ = RIGHT$("0" + LTRIM$(STR$(iMinute)), 2)
	    NumberTime$ = sTmp1$ + sTmp2$
	END FUNCTION

