DECLARE SUB QueryDefault (iShade%, iZoom%, iFrame%, fZoomTime!, bf%, bb%, wf%, wb%, ff%, fb%, ef%, eb%)
REM     *********************************************************************
REM     * WDESKTOP.MOD
REM     *********************************************************************
REM     * Part of WIN.MOD library after split
REM     *
REM     *********************************************************************
REM     * 931107: Split...
REM     *--------------------------------------------------------------------
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'
	DEFINT A-Z

'       ---------------------------------------------------------------------
'        WinDesktop:
'       ---------------------------------------------------------------------
	SUB WinDesktop (iFlag, sRubrik$, iFillChar, iStatus)
	    STATIC sVio$
	    STATIC iRow, iCol
	    SELECT CASE iFlag
		   CASE TRUE
			iRow = CSRLIN
			iCol = POS(0)
			LOCATE 1, 1, 0
		      
			CALL QueryDefault(dShade, dZoom, dFrame, fZoomTime!, bf, bb, wf, wb, ff, fb, ef, eb)

			sVio$ = VioSpace$(1, 1, 25, 80)
			CALL VioGetWindow(1, 1, 25, 80, sVio$)

			CALL VioFrame(1, 1, 25, 80, VioColor(wf, wb), 32)

			FOR iCounter = 1 TO 25
			    CALL VioPrint(iCounter, 1, STRING$(80, iFillChar))
			NEXT

			sTemp$ = RTRIM$(LTRIM$(sRubrik$))
			IF sTemp$ <> "" THEN
			   CALL VioCPrint(1, 1, VioColor(bb, bf), SPACE$(80))
			   IF LEN(sTemp$) > (78) THEN
			      sTemp$ = LEFT$(sTemp$, 78)
			   END IF
			   CALL VioPrint(1, 2, sTemp$)
			END IF

			IF iStatus = TRUE THEN
			   CALL VioCPrint(25, 1, VioColor(bb, bf), SPACE$(80))
			END IF

			sVio$ = sVio$ + CHR$(1) + CHR$(1) + CHR$(25) + CHR$(80)

		   CASE FALSE
			CALL VioPutWindow(1, 1, 25, 80, sVio$)
			COLOR WHITE, BLACK
			LOCATE iRow, iCol, 1
		   CASE ELSE
	    END SELECT
	END SUB

