REM     *********************************************************************
REM     * WEDTBOOL.MOD
REM     *********************************************************************
REM     * Part of WIN.MOD library after split
REM     *
REM     *********************************************************************
REM     * 931107: Split...
REM     *--------------------------------------------------------------------
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'
	DEFINT A-Z

'       ---------------------------------------------------------------------
'        WinEditBool:
'       ---------------------------------------------------------------------
	FUNCTION WinEditBool (hwnd AS WINDOWTYPE, iCurVal, iRow, iCol, sSelect$, aiRet())
	    sFirstStr$ = UCASE$(LEFT$(sSelect$, 1))
	    sLastStr$ = UCASE$(RIGHT$(sSelect$, 1))

	    iQuit = FALSE
	    DO
	       IF iCurVal = FALSE THEN
		  CALL WinEditPrint(hwnd, iRow, iCol, sFirstStr$)
	       ELSE
		  CALL WinEditPrint(hwnd, iRow, iCol, sLastStr$)
	       END IF
	       LOCATE hwnd.iRow1 + iRow, hwnd.iCol1 + iCol, 1
	       CALL KbdInkey(IDKWAIT, iScan, iShift)
	       LOCATE , , 0

	       SELECT CASE iScan
		      CASE IS > 31
			   sTmp$ = UCASE$(CHR$(iScan))
			   IF sTmp$ = sLastStr$ THEN
			      iCurVal = TRUE
			   ELSEIF sTmp$ = sFirstStr$ THEN
			      iCurVal = FALSE
			   END IF
		      CASE ELSE
			   FOR iCounter = 1 TO UBOUND(aiRet)
			       IF iScan = aiRet(iCounter) THEN
				  WinEditBool = iScan
				  iQuit = TRUE
				  EXIT FOR
			       END IF
			   NEXT iCounter
	       END SELECT
	    LOOP WHILE iQuit = FALSE

	END FUNCTION

'       ---------------------------------------------------------------------
'        WinEditCheck:
'       ---------------------------------------------------------------------
	FUNCTION WinEditCheck (hwnd AS WINDOWTYPE, iCurVal, iRow, iCol, sText$, aiRet())
	    iQuit = FALSE
	    DO
	       IF iCurVal = TRUE THEN
		  CALL WinFieldPrint(hwnd, iRow, iCol, "[X] " + sText$)
	       ELSE
		  CALL WinFieldPrint(hwnd, iRow, iCol, "[ ] " + sText$)
	       END IF

	       LOCATE hwnd.iRow1 + iRow, hwnd.iCol1 + iCol + 1, 1
	       CALL KbdInkey(IDKWAIT, iScan, iShift)
	       LOCATE , , 0

	       SELECT CASE iScan
		      CASE KEYSPACE
			   IF iCurVal = TRUE THEN
			      iCurVal = FALSE
			   ELSE
			      iCurVal = TRUE
			   END IF
		      CASE ELSE
			   FOR iCounter = 1 TO UBOUND(aiRet)
			       IF iScan = aiRet(iCounter) THEN
				  WinEditCheck = iScan
				  iQuit = TRUE
				  EXIT FOR
			       END IF
			   NEXT iCounter
	       END SELECT
	    LOOP WHILE iQuit = FALSE

	END FUNCTION

'       ---------------------------------------------------------------------
'        WinEditOption:
'       ---------------------------------------------------------------------
	FUNCTION WinEditOption (hwnd AS WINDOWTYPE, iCurVal, iRow, iCol, sText$, aiRet())
	    iQuit = FALSE
	    DO
	       IF iCurVal = TRUE THEN
		  CALL WinFieldPrint(hwnd, iRow, iCol, "(" + CHR$(7) + ") " + sText$)
	       ELSE
		  CALL WinFieldPrint(hwnd, iRow, iCol, "( ) " + sText$)
	       END IF

	       LOCATE hwnd.iRow1 + iRow, hwnd.iCol1 + iCol + 1, 1
	       CALL KbdInkey(IDKWAIT, iScan, iShift)
	       LOCATE , , 0

	       SELECT CASE iScan
		      CASE KEYSPACE
			   IF iCurVal = TRUE THEN
			      iCurVal = FALSE
			   ELSE
			      iCurVal = TRUE
			   END IF
		      CASE ELSE
			   FOR iCounter = 1 TO UBOUND(aiRet)
			       IF iScan = aiRet(iCounter) THEN
				  WinEditOption = iScan
				  iQuit = TRUE
				  EXIT FOR
			       END IF
			   NEXT iCounter
	       END SELECT
	    LOOP WHILE iQuit = FALSE

	END FUNCTION

