DECLARE FUNCTION FieldChange% (iFlag%, iVarType%, sVarName$, sFormat$, sEdFld$)
DECLARE SUB FieldEdit ()
DECLARE SUB FieldLocate (iFlag%)
DECLARE SUB FieldValues (iVarType%, sVarName$, sFormat$, sEdFld$)
DECLARE SUB FileNew ()
DECLARE SUB FileOpen ()
DECLARE SUB FileSave ()
DECLARE SUB FileSaveAs ()
DECLARE SUB HideField ()
DECLARE SUB MenuMain ()
DECLARE SUB RedrawEditPos ()
DECLARE SUB RedrawEditWindow ()
DECLARE SUB RedrawFields (iFlag%)
DECLARE SUB SourceFixVar (sVarName$, sTypeVar$)
DECLARE FUNCTION SourceInfo% (sSubName$, sTypeName$, sTypeVar$, sTitle$)
DECLARE SUB SourceWin (sTitle$, sTypeName$, sTypeVar$, sWTitle$)
REM     ********************************************************************
DECLARE FUNCTION FileBoxOpen% (sWild$, sPath$, sFile$)
DECLARE FUNCTION FileBoxSaveAs% (sFile$, sExt$, sPath$)
REM     ********************************************************************
REM     *
REM     *
REM     *
REM     *                      W i n S c r e e n
REM     *
REM     *
REM     *
REM     *
REM     *
REM     *                                                  First : 930916
REM     *                                                   Last : 931204
REM     *                                                   Time : 23h
REM     *
REM     *
REM     *
REM     ********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'

	TYPE FIELDTYPE
	    iRow1       AS INTEGER
	    iCol1       AS INTEGER
	    iRowLen     AS INTEGER
	    iColLen     AS INTEGER
	    iFieldType  AS INTEGER
	    iFieldEdit  AS INTEGER
	    sFormat     AS STRING * 55
	    sVarName    AS STRING * 55
	END TYPE

	CONST IDFSTATIC = 1
	CONST IDFLINE = 2
	CONST IDFSTRING = 3
	CONST IDFINT = 4
	CONST IDFFLOAT = 5
	CONST IDFDATE = 6
	CONST IDFTIME = 7
	CONST IDFDROP = 8
	CONST IDFBUTTON = 9
	CONST IDFBOOL = 10
	CONST IDFCHECK = 11
	CONST IDFOPTION = 12
	CONST IDFLISTBOX = 13
	CONST IDFFRAME = 14

	DEFINT A-Z

	DIM SHARED hwndEdit AS WINDOWTYPE
	DIM SHARED sEdit$, sRubrik$
	DIM SHARED iRow1, iCol1, iRow2, iCol2

	DIM SHARED sPath$, sFile$, iSaved
	
	REDIM SHARED fldList(0) AS FIELDTYPE
	DIM SHARED iCurFld

	iSaved = TRUE

	CALL WinSetDefault(TRUE, FALSE, 255, .02, BLUE, WHITE, BRBLUE, WHITE, BLUE, WHITE, WHITE, RED)

	CALL WinDesktop(TRUE, "WinScreen 0.124 - Software Technologies (C) 1993", 177, TRUE)

	CALL WinStatusPrint(3, FALSE, "F10=Menu")
	CALL WinStatusPrint(60, FALSE, "[SIZE]")

	CALL FileNew
	CALL RedrawEditWindow

	quit = FALSE
	DO

	   CALL KbdInkey(IDKWAIT, iScan, iShift)
	   iStatus = 0
	   IF (iShift AND 1) = 1 OR (iShift AND 2) = 2 THEN
	      iStatus = 1
	   END IF
	   SELECT CASE iScan
		  CASE KEYUARROW
		       SELECT CASE iStatus
			      CASE 1
				   IF iRow2 > 3 THEN
				      iRow2 = iRow2 - 1
				   END IF
			      CASE ELSE
				   IF iRow1 > 1 THEN
				      iRow1 = iRow1 - 1
				   END IF
		       END SELECT
		       CALL RedrawEditWindow
		  CASE KEYDARROW
		       SELECT CASE iStatus
			      CASE 1
				   IF iRow1 + iRow2 < 25 THEN
				      iRow2 = iRow2 + 1
				   END IF
			      CASE ELSE
				   IF iRow1 + iRow2 < 25 THEN
				      iRow1 = iRow1 + 1
				   END IF
		       END SELECT
		       CALL RedrawEditWindow
		  CASE KEYLARROW
		       SELECT CASE iStatus
			      CASE 1
				   IF iCol2 > 4 THEN
				      iCol2 = iCol2 - 1
				   END IF
			      CASE ELSE
				   IF iCol1 > 1 THEN
				      iCol1 = iCol1 - 1
				   END IF
		       END SELECT
		       CALL RedrawEditWindow
		  CASE KEYRARROW
		       SELECT CASE iStatus
			      CASE 1
				   IF iCol1 + iCol2 < 80 THEN
				      iCol2 = iCol2 + 1
				   END IF
			      CASE ELSE
				   IF iCol1 + iCol2 < 80 THEN
				      iCol1 = iCol1 + 1
				   END IF
		       END SELECT
		       CALL RedrawEditWindow
		  CASE KEYENTER
		       CALL WinStatusPrint(3, FALSE, "Ins=Add  F7=Clone  Del=Remove  F4=Sort  PgUp/PgDn=Select")
		       CALL WinStatusPrint(60, FALSE, "[EDIT]")
		       CALL FieldEdit
		       CALL WinStatusPrint(1, FALSE, SPACE$(80))
		       CALL WinStatusPrint(3, FALSE, "F10=Menu")
		       CALL WinStatusPrint(60, FALSE, "[SIZE]")
		  CASE KEYESC
		       IF WinMessageBox(2, "EXIT", "This will exit WinScreen", "", "Are you sure ?") = TRUE THEN
			  quit = TRUE
		       END IF
		       
		  CASE KEYF10
		       CALL MenuMain
		  CASE ELSE
	   END SELECT

	LOOP WHILE quit = FALSE

	CALL WinCloseWindow(hwndEdit, sEdit$)

	CALL WinDesktop(0, "", 0, 0)

	END

'       ---------------------------------------------------------------------
'        FieldChange
'       ---------------------------------------------------------------------
	FUNCTION FieldChange (iFlag, iVarType, sVarName$, sFormat$, sEdFld$)
	    STATIC STATICiVarType

	    IF iVarType = 0 THEN
	       iVarType = STATICiVarType
	    END IF

	    IF iCurFld = 0 AND iFlag <> 1 THEN
	       BEEP
	       FieldChange = FALSE
	       EXIT FUNCTION
	    END IF

	    'CONST IDFSTATIC = 1
	    'CONST IDFLINE = 2
	    'CONST IDFSTRING = 3
	    'CONST IDFINT = 4
	    'CONST IDFFLOAT = 5
	    'CONST IDFDATE = 6
	    'CONST IDFTIME = 7
	    'CONST IDFDROP = 8
	    'CONST IDFBUTTON = 9
	    'CONST IDFBOOL = 10
	    'CONST IDFCHECK = 11
	    'CONST IDFOPTION = 12
	    'CONST IDFLISTBOX = 13
	    'CONST IDFFRAME = 14


	    REDIM asDrop$(14)
		  asDrop$(1) = "Static Text"
		  asDrop$(2) = "Static Line"
		  asDrop$(3) = "($) String"
		  asDrop$(4) = "(%) Integer"
		  asDrop$(5) = "(#) Double"
		  asDrop$(6) = "($) Date"
		  asDrop$(7) = "($) Time"
		  asDrop$(8) = "(%) Combobox"
		  asDrop$(9) = "(%) Button"
		  asDrop$(10) = "(%) Bool"
		  asDrop$(11) = "(%) Check"
		  asDrop$(12) = "(%) Option"
		  asDrop$(13) = "Listbox"
		  asDrop$(14) = "Static Frame"

	    DIM hwnd AS WINDOWTYPE
	    sVio$ = WinOpenWindow(hwnd, 6, 3, 9, 74, "FIELDVALUES", -1, -1, -1)

	    CALL WinPrint(hwnd, 2, 2, " Fieldtype:")
	    CALL WinPrint(hwnd, 3, 2, "  Text/var:")
	    CALL WinPrint(hwnd, 4, 2, "Format/Len:")
	    CALL WinPrint(hwnd, 5, 2, "    Edit ?:")

	    CALL WinPrint(hwnd, 7, 2, STRING$(71, ""))
	    CALL WinPrint(hwnd, 8, 4, "F2=Save  Esc=Cancel")

	    CALL WinEditPrint(hwnd, 2, 16, StrFormat$(IDSFDROP, SPACE$(15), asDrop$(iVarType)))
	    CALL WinEditPrint(hwnd, 3, 16, StrFormat$(IDSFSTR, SPACE$(55), sVarName$))
	    CALL WinEditPrint(hwnd, 4, 16, StrFormat$(IDSFSTR, SPACE$(55), sFormat$))
	    CALL WinEditPrint(hwnd, 5, 16, StrFormat$(IDSFSTR, SPACE$(1), sEdFld$))

	    REDIM iRet(7)
		  iRet(1) = KEYENTER
		  iRet(2) = KEYDARROW
		  iRet(3) = KEYUARROW
		  iRet(4) = KEYDARROW
		  iRet(5) = KEYUARROW
		  iRet(6) = KEYESC
		  iRet(7) = KEYF2

	    fieldid = 1
	    maxfield = 4

	    quit = FALSE
	    DO

	       SELECT CASE fieldid
		      CASE 1
			   iRetKey = WinEditDrop(hwnd, asDrop$(), iVarType, 2, 16, 15, iRet(), IDHNULL)
		      CASE 2
			   iRetKey = WinEditString(hwnd, sVarName$, 3, 16, 55, iRet(), IDHNULL)
		      CASE 3
			   iRetKey = WinEditString(hwnd, sFormat$, 4, 16, 55, iRet(), IDHNULL)
		      CASE 4
			   iRetKey = WinEditString(hwnd, sEdFld$, 5, 16, 1, iRet(), IDHYN)
		      CASE ELSE
	       END SELECT
	       SELECT CASE iRetKey
		      CASE KEYENTER, KEYDARROW, KEYTAB
			   fieldid = fieldid + 1
		      CASE KEYUARROW, KEYBTAB
			   fieldid = fieldid - 1
		      CASE KEYF2
			   FieldChange = TRUE
			   quit = TRUE
		      CASE KEYESC
			   FieldChange = FALSE
			   quit = TRUE
		      CASE ELSE
	       END SELECT
	       IF fieldid < 1 THEN
		  fieldid = 1
	       ELSEIF fieldid > maxfield THEN
		      fieldid = maxfield
	       END IF
	    LOOP WHILE quit = FALSE

	    STATICiVarType = iVarType

	    CALL WinCloseWindow(hwnd, sVio$)
	END FUNCTION

'       ---------------------------------------------------------------------
'        FieldEdit:
'       ---------------------------------------------------------------------
	SUB FieldEdit ()
	    CALL RedrawEditPos
	    quit = FALSE
	    DO
	       CALL FieldLocate(TRUE)
	       CALL KbdInkey(IDKWAIT, iScan, iShift)
	       LOCATE , , 0
	       iStatus = 0
	       IF (iShift AND 1) = 1 OR (iShift AND 2) = 2 THEN
		  iStatus = 1
	       END IF
	       SELECT CASE iScan
		      CASE KEYUARROW
			   CALL HideField
			   SELECT CASE iStatus
				  CASE 1
				       IF fldList(iCurFld).iRowLen > 1 THEN
					  fldList(iCurFld).iRowLen = fldList(iCurFld).iRowLen - 1
				       END IF
				  CASE ELSE
				       IF fldList(iCurFld).iRow1 > 1 THEN
					  fldList(iCurFld).iRow1 = fldList(iCurFld).iRow1 - 1
				       END IF
			   END SELECT
			   CALL RedrawFields(TRUE)
		      CASE KEYDARROW
			   CALL HideField
			   SELECT CASE iStatus
				  CASE 1
				       IF fldList(iCurFld).iRow1 + fldList(iCurFld).iRowLen < iRow2 - 1 THEN
					  fldList(iCurFld).iRowLen = fldList(iCurFld).iRowLen + 1
				       END IF
				  CASE ELSE
				       IF fldList(iCurFld).iRow1 + fldList(iCurFld).iRowLen < iRow2 - 1 THEN
					  fldList(iCurFld).iRow1 = fldList(iCurFld).iRow1 + 1
				       END IF
			   END SELECT
			   CALL RedrawFields(TRUE)
		      CASE KEYLARROW
			   CALL HideField
			   SELECT CASE iStatus
				  CASE 1
				       IF fldList(iCurFld).iColLen > 1 THEN
					  fldList(iCurFld).iColLen = fldList(iCurFld).iColLen - 1
				       END IF
				  CASE ELSE
				       IF fldList(iCurFld).iCol1 > 1 THEN
					  fldList(iCurFld).iCol1 = fldList(iCurFld).iCol1 - 1
				       END IF
			   END SELECT
			   CALL RedrawFields(TRUE)
		      CASE KEYRARROW
			   CALL HideField
			   SELECT CASE iStatus
				  CASE 1
				       IF fldList(iCurFld).iCol1 + fldList(iCurFld).iColLen < iCol2 THEN
					  fldList(iCurFld).iColLen = fldList(iCurFld).iColLen + 1
				       END IF
				  CASE ELSE
				       IF fldList(iCurFld).iCol1 + fldList(iCurFld).iColLen < iCol2 THEN
					  fldList(iCurFld).iCol1 = fldList(iCurFld).iCol1 + 1
				       END IF
			   END SELECT
			   CALL RedrawFields(TRUE)


		      CASE KEYPAGEUP
			   IF iCurFld > 1 THEN
			      iCurFld = iCurFld - 1
			      CALL RedrawEditPos
			   END IF

		      CASE KEYPAGEDN
			   IF iCurFld < UBOUND(fldList) THEN
			      iCurFld = iCurFld + 1
			      CALL RedrawEditPos
			   END IF

		      CASE KEYINS
			   iVarType = 0
			   sVarName$ = ""
			   sFormat$ = ""
			   sEdFld$ = "J"
			   IF FieldChange(1, iVarType, sVarName$, sFormat$, sEdFld$) = TRUE THEN
			      REDIM PRESERVE fldList(UBOUND(fldList) + 1) AS FIELDTYPE
			      fldList(UBOUND(fldList)).iRow1 = 1
			      fldList(UBOUND(fldList)).iCol1 = 1
			      iCurFld = UBOUND(fldList)
			      CALL FieldValues(iVarType, sVarName$, sFormat$, sEdFld$)
			      CALL RedrawFields(TRUE)
			   END IF

		      CASE KEYF7
			   iVarType = fldList(iCurFld).iFieldType
			   sVarName$ = fldList(iCurFld).sVarName
			   sFormat$ = fldList(iCurFld).sFormat
			   IF fldList(iCurFld).iFieldEdit = TRUE THEN
			      sEdFld$ = "J"
			   ELSE
			      sEdFld$ = "N"
			   END IF
			   REDIM PRESERVE fldList(UBOUND(fldList) + 1) AS FIELDTYPE
			   fldList(UBOUND(fldList)).iRow1 = 1
			   fldList(UBOUND(fldList)).iCol1 = 1
			   iCurFld = UBOUND(fldList)
			   CALL FieldValues(iVarType, sVarName$, sFormat$, sEdFld$)
			   CALL RedrawFields(TRUE)
			    
		      CASE KEYDEL
			   IF iCurFld <> 0 THEN
			      IF WinMessageBox(2, "VARNING", "Ta bort flt", "", "r du sker?") = TRUE THEN
				 CALL HideField
				 FOR iCounter = iCurFld TO UBOUND(fldList) - 1
				     fldList(iCounter) = fldList(iCounter + 1)
				 NEXT iCounter
				 REDIM PRESERVE fldList(UBOUND(fldList) - 1) AS FIELDTYPE
				 iCurFld = 1
				 CALL RedrawFields(TRUE)
			      END IF
			   ELSE
			      BEEP
			   END IF

		      CASE KEYENTER
			   iVarType = fldList(iCurFld).iFieldType
			   sVarName$ = fldList(iCurFld).sVarName
			   sFormat$ = fldList(iCurFld).sFormat
			   IF fldList(iCurFld).iFieldEdit = TRUE THEN
			      sEdFld$ = "J"
			   ELSE
			      sEdFld$ = "N"
			   END IF

			   IF FieldChange(2, iVarType, sVarName$, sFormat$, sEdFld$) = TRUE THEN
			      CALL HideField
			      CALL FieldValues(iVarType, sVarName$, sFormat$, sEdFld$)
			      sVarName$ = RTRIM$(sVarName$)
			      sFormat$ = RTRIM$(sFormat$)
			      CALL RedrawFields(TRUE)
			   END IF

		      CASE KEYF4
			   DIM hwnd AS WINDOWTYPE
			   sVio$ = "Sorting fields"
			   CALL WinPercentBox(hwnd, 0, sVio$, 7, 15, 1, UBOUND(fldList))

			   DIM tmpList AS FIELDTYPE
			   FOR iOuter = 1 TO UBOUND(fldList)
			       CALL WinPercentBox(hwnd, 1, "", 0, 0, 0, iOuter)
			       FOR iInner = 1 TO UBOUND(fldList)
				   iSize1 = (fldList(iOuter).iRow1 * 100) + fldList(iOuter).iCol1
				   iSize2 = (fldList(iInner).iRow1 * 100) + fldList(iInner).iCol1
				   IF iSize1 < iSize2 THEN
				      tmpList = fldList(iOuter)
				      fldList(iOuter) = fldList(iInner)
				      fldList(iInner) = tmpList
				   END IF
			       NEXT iInner
			   NEXT iOuter
			   iCurFld = 1
			   CALL WinPercentBox(hwnd, 2, sVio$, 0, 0, 0, 0)
		      CASE KEYESC
			   quit = TRUE

		      CASE ELSE
	       END SELECT
	    LOOP WHILE quit = FALSE

	END SUB

'       ---------------------------------------------------------------------
'        FieldLocate
'       ---------------------------------------------------------------------
	SUB FieldLocate (iFlag)
	    IF iCurFld = 0 THEN
	       EXIT SUB
	    END IF
	    IF iFlag = TRUE THEN
	       LOCATE hwndEdit.iRow1 + fldList(iCurFld).iRow1, hwndEdit.iCol1 + fldList(iCurFld).iCol1, 1
	    ELSE
	       LOCATE , , 0
	    END IF
	END SUB

'       ---------------------------------------------------------------------
'        FieldValues:
'       ---------------------------------------------------------------------
	SUB FieldValues (iVarType, sVarName$, sFormat$, sEdFld$)
	    sVarName$ = RTRIM$(sVarName$)
	    sFormat$ = RTRIM$(sFormat$)
	    SELECT CASE iVarType
		   CASE IDFSTATIC
			IF LEN(sVarName$) > 0 THEN
			   fldList(iCurFld).iColLen = LEN(sVarName$)
			ELSE
			   fldList(iCurFld).iColLen = 1
			END IF
		   CASE IDFLINE
			fldList(iCurFld).iColLen = 1
		   CASE IDFSTRING
			IF VAL(sFormat$) = 0 THEN
			   fldList(iCurFld).iColLen = 1
			ELSE
			   fldList(iCurFld).iColLen = VAL(sFormat$)
			END IF
		   CASE IDFINT, IDFFLOAT
			fldList(iCurFld).iColLen = LEN(sFormat$)
		   CASE IDFDATE
			fldList(iCurFld).iColLen = 8
		   CASE IDFTIME
			fldList(iCurFld).iColLen = 6
		   CASE IDFDROP
			IF VAL(sFormat$) = 0 THEN
			   fldList(iCurFld).iColLen = 5
			ELSE
			   fldList(iCurFld).iColLen = VAL(sFormat$) + 2
			END IF
		   CASE IDFBUTTON
			fldList(iCurFld).iColLen = LEN(StrTrim$(sFormat$)) + 6
		   CASE IDFBOOL
			fldList(iCurFld).iColLen = 1
		   CASE IDFCHECK
			fldList(iCurFld).iColLen = LEN(StrTrim$(sFormat$)) + 4
		   CASE IDFOPTION
			fldList(iCurFld).iColLen = LEN(StrTrim$(sFormat$)) + 4
		   CASE IDFLISTBOX
			BEEP
		   CASE IDFFRAME
			IF fldList(iCurFld).iRowLen = 0 THEN
			   fldList(iCurFld).iRowLen = fldList(iCurFld).iRow1 + 4
			END IF
			IF fldList(iCurFld).iColLen = 0 THEN
			   fldList(iCurFld).iColLen = fldList(iCurFld).iCol1 + 8
			END IF
		   CASE ELSE
	    END SELECT

	    fldList(iCurFld).iFieldType = iVarType
	    fldList(iCurFld).sFormat = sFormat$
	    fldList(iCurFld).sVarName = sVarName$
	    IF sEdFld$ = "J" THEN
	       fldList(iCurFld).iFieldEdit = TRUE
	    ELSE
	       fldList(iCurFld).iFieldEdit = FALSE
	    END IF
	END SUB

'       ---------------------------------------------------------------------
'        FileNew: Called when user selects New... in menu.            880910
'       ---------------------------------------------------------------------
	SUB FileNew ()
	    IF iSaved = FALSE THEN
	       IF WinMessageBox(2, "VARNING", "Screen not saved", "", "New anyway ?") = FALSE THEN
		  EXIT SUB
	       END IF
	    END IF

	    REDIM fldList(0) AS FIELDTYPE
	    iCurFld = 0

	    iRow1 = 3
	    iCol1 = 20
	    iRow2 = 20
	    iCol2 = 55

	    sRubrik$ = "NONAME.WSD"

	END SUB

'       ---------------------------------------------------------------------
'        FileOpen:                                                    880910
'       ---------------------------------------------------------------------
	SUB FileOpen ()
	    IF iSaved = FALSE THEN
	       IF WinMessageBox(2, "VARNING", "Screen not saved", "", "Open anyway ?") = FALSE THEN
		  EXIT SUB
	       END IF
	    END IF
	    sTempPath$ = sPath$
	    sTempFile$ = sFile$
	    IF FileBoxOpen("*.WSD", sTempPath$, sTempFile$) = FALSE THEN
	       EXIT SUB
	    END IF
	    sPath$ = sTempPath$
	    sFile$ = sTempFile$
	    IF RIGHT$(sPath$, 1) = "\" THEN
	       sPath$ = LEFT$(sPath$, LEN(sPath$) - 1)
	    END IF
	    IF DosQFile(sPath$ + "\" + sFile$ + CHR$(0), IDFOPEN) = TRUE THEN
	       iSaved = TRUE
	       CALL FileNew

	       hFile = FREEFILE
	       OPEN sPath$ + "\" + sFile$ FOR BINARY AS #hFile
		    GET #hFile, , hwndEdit

		    GET #hFile, , iRow1
		    GET #hFile, , iCol1
		    GET #hFile, , iRow2
		    GET #hFile, , iCol2

		    GET #hFile, , iCurFld
		    GET #hFile, , iTmp

		    REDIM fldList(iTmp) AS FIELDTYPE

		    FOR iCounter = 1 TO UBOUND(fldList)
			GET #hFile, , fldList(iCounter)
		    NEXT iCounter
	       CLOSE #hFile

	       sRubrik$ = sFile$
	    ELSE
	       void = WinMessageBox(0, "FEL", "File could not be opened", "", sFile$)
	    END IF
	END SUB

'       ---------------------------------------------------------------------
'        FileSave:                                                    880910
'       ---------------------------------------------------------------------
	SUB FileSave ()
	    IF LTRIM$(sFile$) = "" THEN
	       CALL FileSaveAs
	    ELSE
	       hFile = FREEFILE
	       IF RIGHT$(sPath$, 1) = "\" THEN
		  sPath$ = LEFT$(sPath$, LEN(sPath$) - 1)
	       END IF
	       OPEN sPath$ + "\" + sFile$ FOR BINARY AS #hFile
		    PUT #hFile, , hwndEdit

		    PUT #hFile, , iRow1
		    PUT #hFile, , iCol1
		    PUT #hFile, , iRow2
		    PUT #hFile, , iCol2

		    PUT #hFile, , iCurFld
		    iTmp = UBOUND(fldList)
		    PUT #hFile, , iTmp

		    FOR iCounter = 1 TO UBOUND(fldList)
			PUT #hFile, , fldList(iCounter)
		    NEXT iCounter
	       CLOSE #hFile
	       iSaved = TRUE
	    END IF
	END SUB

'       ---------------------------------------------------------------------
'        FileSaveAs:                                                  880918
'       ---------------------------------------------------------------------
	SUB FileSaveAs ()
	    sTempPath$ = ""
	    sTempFile$ = "PICTURE.WSD"
	    IF FileBoxSaveAs(sTempFile$, ".WSD", sTempPath$) = FALSE THEN
	       EXIT SUB
	    END IF
	    sPath$ = sTempPath$
	    sFile$ = sTempFile$
	    IF RIGHT$(sPath$, 1) = "\" THEN
	       sPath$ = LEFT$(sPath$, LEN(sPath$) - 1)
	    END IF
	    IF INSTR(sFile$, ".") = FALSE THEN
	       sFile$ = sFile$ + ".WSD"
	    END IF

	    CALL FileSave

	    sRubrik$ = sFile$
	END SUB

'       ---------------------------------------------------------------------
'        HideField:
'       ---------------------------------------------------------------------
	SUB HideField ()
	    iRow11 = fldList(iCurFld).iRow1
	    iCol11 = fldList(iCurFld).iCol1
	    iRow22 = fldList(iCurFld).iRowLen
	    iCol22 = fldList(iCurFld).iColLen

	    FOR iCounter = 0 TO iRow22
		CALL WinColorPrint(hwndEdit, iRow11 + iCounter, iCol11, hwndEdit.wfcolor, hwndEdit.wbcolor, SPACE$(iCol22 + 1))
	    NEXT iCounter
	END SUB

'       ---------------------------------------------------------------------
'        MenuMain:
'       ---------------------------------------------------------------------
	SUB MenuMain ()
	    DIM hwndMenu AS WINDOWTYPE
	    DIM li AS LISTBOXTYPE

	    REDIM sMenu$(6)
		  sMenu$(1) = "New"
		  sMenu$(2) = "Load..."
		  sMenu$(3) = "Save"
		  sMenu$(4) = "Save As..."
		  sMenu$(5) = ""
		  sMenu$(6) = "Create Source..."

	    sVio$ = "MENU"
	    void = WinMenuChoice(hwndMenu, 1, 4, 10, sVio$, sMenu$(), li)

	    quit = FALSE

	    DO
	       iRet = WinMenuChoice(hwndMenu, 2, 0, 0, "", sMenu$(), li)
	       SELECT CASE iRet
		      CASE KEYENTER
			   SELECT CASE li.curpos
				  CASE 1
				       CALL FileNew
				       quit = TRUE
				  CASE 2
				       CALL FileOpen
				       quit = TRUE
				  CASE 3
				       CALL FileSave
				  CASE 4
				       CALL FileSaveAs
				  CASE 6
				       IF SourceInfo(sSubName$, sTypeName$, sTypeVar$, sTitle$) = TRUE THEN
					  CALL SourceWin(sSubName$, sTypeName$, sTypeVar$, sTitle$)
				       END IF
				  CASE ELSE
				       quit = TRUE
			   END SELECT
		      CASE KEYESC
			   quit = TRUE
		      CASE ELSE
	       END SELECT
	    LOOP WHILE quit = FALSE

	    void = WinMenuChoice(hwndMenu, 3, 0, 0, sVio$, sMenu$(), li)
	    CALL RedrawEditWindow
	END SUB

'       ---------------------------------------------------------------------
'
'       ---------------------------------------------------------------------
	SUB RedrawEditPos ()
	    IF iCurFld > 0 THEN
	       sRow1$ = RIGHT$(" " + LTRIM$(STR$(fldList(iCurFld).iRow1)), 2)
	       sCol1$ = RIGHT$(" " + LTRIM$(STR$(fldList(iCurFld).iCol1)), 2)
	       sFld$ = RIGHT$("  " + LTRIM$(STR$(iCurFld)), 3)

	       sTmp$ = "(" + sRow1$ + "," + sCol1$ + " -> " + sFld$ + ")"
	       CALL WinStatusPrint(67, FALSE, sTmp$)
	    END IF
	END SUB

'       ---------------------------------------------------------------------
'        RedrawEditWindow:
'       ---------------------------------------------------------------------
	SUB RedrawEditWindow ()
	    IF StrTrim$(sEdit$) <> "" THEN
	       CALL WinCloseWindow(hwndEdit, sEdit$)
	    END IF
	    sRow1$ = RIGHT$(" " + LTRIM$(STR$(iRow1)), 2)
	    sRow2$ = RIGHT$(" " + LTRIM$(STR$(iRow2)), 2)
	    sCol1$ = RIGHT$(" " + LTRIM$(STR$(iCol1)), 2)
	    sCol2$ = RIGHT$(" " + LTRIM$(STR$(iCol2)), 2)

	    sTmp$ = "(" + sRow1$ + "," + sCol1$ + "  " + sRow2$ + "," + sCol2$ + ")"
	    CALL WinStatusPrint(67, FALSE, sTmp$)


	    sEdit$ = WinOpenWindow(hwndEdit, iRow1, iCol1, iRow2, iCol2, sRubrik$, -1, -1, -1)

	    CALL RedrawFields(FALSE)
	END SUB

'       --------------------------------------------------------------------
'        RedrawFields:
'       --------------------------------------------------------------------
	SUB RedrawFields (iFlag)

	    IF iFlag = TRUE THEN
	       CALL RedrawEditPos
	    END IF
	    FOR iCounter = 1 TO UBOUND(fldList)
		iRow11 = fldList(iCounter).iRow1
		iCol11 = fldList(iCounter).iCol1
		iRow22 = fldList(iCounter).iRowLen
		iCol22 = fldList(iCounter).iColLen
		IF fldList(iCounter).iFieldEdit = TRUE THEN
		   SELECT CASE fldList(iCounter).iFieldType
			  CASE IDFSTATIC
			       CALL WinPrint(hwndEdit, iRow11, iCol11, LEFT$(fldList(iCounter).sVarName, iCol22))
			  CASE IDFSTRING
			       CALL WinEditPrint(hwndEdit, iRow11, iCol11, STRING$(iCol22, "$"))
			  CASE IDFINT
			       CALL WinEditPrint(hwndEdit, iRow11, iCol11, LEFT$(fldList(iCounter).sFormat, iCol22))
			  CASE IDFFLOAT
			       CALL WinEditPrint(hwndEdit, iRow11, iCol11, LEFT$(fldList(iCounter).sFormat, iCol22))
			  CASE IDFDATE
			       CALL WinEditPrint(hwndEdit, iRow11, iCol11, "93/01/01")
			  CASE IDFTIME
			       CALL WinEditPrint(hwndEdit, iRow11, iCol11, "13:57")
			  CASE IDFLINE
			       CALL WinPrint(hwndEdit, iRow11, iCol11, STRING$(iCol22, ""))
			  CASE IDFDROP
			       CALL WinEditPrint(hwndEdit, iRow11, iCol11, STRING$(iCol22 - 2, 176) + CHR$(179) + CHR$(31))
			  CASE IDFBUTTON
			       CALL WinFieldPrint(hwndEdit, iRow11, iCol11, " < " + LEFT$(fldList(iCounter).sFormat, iCol22 - 6) + " > ")
			  CASE IDFBOOL
			       CALL WinEditPrint(hwndEdit, iRow11, iCol11, "B")
			  CASE IDFCHECK
			       CALL WinFieldPrint(hwndEdit, iRow11, iCol11, "[ ] " + LEFT$(fldList(iCounter).sFormat, iCol22 - 4))
			  CASE IDFOPTION
			       CALL WinFieldPrint(hwndEdit, iRow11, iCol11, "( ) " + LEFT$(fldList(iCounter).sFormat, iCol22 - 4))
			  CASE IDFLISTBOX
			       'CALL WinEditPrint(hwndEdit, iRow11, iCol11, STRING$(iCol22 - 2, 176) + CHR$(179) + CHR$(31))
			  CASE IDFFRAME
			       CALL WinFrame(hwndEdit, RTRIM$(fldList(iCounter).sFormat), iRow11, iCol11, iRow22, iCol22, VAL(fldList(iCounter).sVarName))
			  CASE ELSE
		   END SELECT
		ELSE
		   SELECT CASE fldList(iCounter).iFieldType
			  CASE IDFSTATIC
			       CALL WinPrint(hwndEdit, iRow11, iCol11, LEFT$(fldList(iCounter).sVarName, iCol22))
			  CASE IDFSTRING
			       CALL WinFieldPrint(hwndEdit, iRow11, iCol11, STRING$(iCol22, "$"))
			  CASE IDFINT
			       CALL WinFieldPrint(hwndEdit, iRow11, iCol11, LEFT$(fldList(iCounter).sFormat, iCol22))
			  CASE IDFFLOAT
			       CALL WinFieldPrint(hwndEdit, iRow11, iCol11, LEFT$(fldList(iCounter).sFormat, iCol22))
			  CASE IDFDATE
			       CALL WinFieldPrint(hwndEdit, iRow11, iCol11, "93/01/01")
			  CASE IDFTIME
			       CALL WinFieldPrint(hwndEdit, iRow11, iCol11, "13:57")
			  CASE IDFLINE
			       CALL WinPrint(hwndEdit, iRow11, iCol11, STRING$(iCol22, ""))
			  CASE IDFDROP
			       CALL WinFieldPrint(hwndEdit, iRow11, iCol11, STRING$(iCol22 - 2, 176) + CHR$(179) + CHR$(31))
			  CASE IDFBUTTON
			       CALL WinFieldPrint(hwndEdit, iRow11, iCol11, " < " + LEFT$(fldList(iCounter).sFormat, iCol22 - 6) + " > ")
			  CASE IDFBOOL
			       CALL WinFieldPrint(hwndEdit, iRow11, iCol11, "B")
			  CASE IDFCHECK
			       CALL WinFieldPrint(hwndEdit, iRow11, iCol11, "[ ] " + LEFT$(fldList(iCounter).sFormat, iCol22 - 4))
			  CASE IDFOPTION
			       CALL WinFieldPrint(hwndEdit, iRow11, iCol11, "( ) " + LEFT$(fldList(iCounter).sFormat, iCol22 - 4))
			  CASE IDFFRAME
			       CALL WinFrame(hwndEdit, RTRIM$(fldList(iCounter).sFormat), iRow11, iCol11, iRow22, iCol22, VAL(fldList(iCounter).sVarName))
			  CASE ELSE
		   END SELECT

		END IF
	    NEXT iCounter
	END SUB

'
'
'
	SUB SourceFixVar (sVarName$, sTypeVar$)
	    IF INSTR(sVarName$, ".") <> 0 THEN
	       sVarName$ = sTypeVar$ + LEFT$(sVarName$, LEN(sVarName$) - 1)
	    END IF
	END SUB

'       ---------------------------------------------------------------------
'        TestFunktion: Form created by QuickScreen.                    930502
'       ---------------------------------------------------------------------
	FUNCTION SourceInfo (sSubName$, sTypeName$, sTypeVar$, sTitle$)
	    DIM hwnd AS WINDOWTYPE
	    sVio$ = WinOpenWindow$(hwnd, 7, 20, 10, 42, "SELECT SOURCE SETTINGS", -1, -1, -1)

	    CALL WinPrint(hwnd, 3, 3, "Function :")
	    CALL WinPrint(hwnd, 4, 3, "TYPE     :")
	    CALL WinPrint(hwnd, 5, 3, "TYPE var :")
	    CALL WinPrint(hwnd, 6, 3, "Titletxt :")
	    CALL WinPrint(hwnd, 8, 2, STRING$(42 - 3, 196))
	    CALL WinPrint(hwnd, 9, 10, "F2=Save     Esc=Cancel")
	    vioclr = VioColor(st.iGloebcolor, st.iGlowbcolor)
	    CALL WinEditPrint(hwnd, 3, 14, StrFormat$(IDSFSTR, SPACE$(25), sSubName$))
	    CALL WinEditPrint(hwnd, 4, 14, StrFormat$(IDSFSTR, SPACE$(25), sTypeName$))
	    CALL WinEditPrint(hwnd, 5, 14, StrFormat$(IDSFSTR, SPACE$(25), sTypeVar$))
	    CALL WinEditPrint(hwnd, 6, 14, StrFormat$(IDSFSTR, SPACE$(25), sTitle$))

	    fieldid = 1
	    lastfield = 4
	    REDIM ret(7)
	    ret(1) = KEYF2
	    ret(2) = KEYESC
	    ret(3) = KEYENTER
	    ret(4) = KEYTAB
	    ret(5) = KEYBTAB
	    ret(6) = KEYDARROW
	    ret(7) = KEYUARROW

	    quit = FALSE
	    DO
	       SELECT CASE fieldid
		      CASE 1
			   ret = WinEditString(hwnd, sSubName$, 3, 14, 25, ret(), IDHNULL)
		      CASE 2
			   ret = WinEditString(hwnd, sTypeName$, 4, 14, 25, ret(), IDHNULL)
		      CASE 3
			   ret = WinEditString(hwnd, sTypeVar$, 5, 14, 25, ret(), IDHNULL)
		      CASE 4
			   ret = WinEditString(hwnd, sTitle$, 6, 14, 25, ret(), IDHNULL)
		      CASE ELSE
	       END SELECT
	       SELECT CASE ret
		      CASE KEYTAB, KEYDARROW, KEYENTER
			   fieldid = fieldid + 1
		      CASE KEYBTAB, KEYUARROW
			   fieldid = fieldid - 1
		      CASE KEYF2
			   IF RTRIM$(sSubName$) <> "" THEN
			      SourceInfo = TRUE
			      quit = TRUE
			   ELSE
			      BEEP
			      fieldid = 1
			   END IF
		      CASE KEYESC
			   SourceInfo = FALSE
			   quit = TRUE
		      CASE ELSE
	       END SELECT
	       IF fieldid > lastfield THEN
		  fieldid = lastfield
	       ELSEIF fieldid < 1 THEN
		  fieldid = 1
	       END IF
	    LOOP WHILE quit = FALSE
	    CALL WinCloseWindow(hwnd, sVio$)

	END FUNCTION

'       ---------------------------------------------------------------------
'        SourceWin:
'       ---------------------------------------------------------------------
	SUB SourceWin (sTitle$, sTypeName$, sTypeVar$, sWTitle$)
	    sTempPath$ = ""
	    sTempFile$ = "PICTURE.MOD"
	    IF FileBoxSaveAs(sTempFile$, "*.MOD", sTempPath$) = FALSE THEN
	       EXIT SUB
	    END IF

	    IF RIGHT$(sTempPath$, 1) = "\" THEN
		  sTempPath$ = LEFT$(sTempPath$, LEN(sTempPath$) - 1)
	    END IF

	    IF INSTR(sTempFile$, ".") = FALSE THEN
	       sTempFile$ = sTempFile$ + ".MOD"
	    END IF

	    sTypeName$ = StrTrim$(sTypeName$)
	    sTypeVar$ = StrTrim$(sTypeVar$)

	    iMaxField = UBOUND(fldList)

	    iEditField = 0
	    iTextField = 0
	    FOR iCounter = 1 TO UBOUND(fldList)
		SELECT CASE fldList(iCounter).iFieldType
		       CASE IDFSTATIC, IDFLINE
			    iTextField = iTextField + 1
		       CASE ELSE
			    iEditField = iEditField + 1
		END SELECT
	    NEXT

	    DIM hwnd AS WINDOWTYPE

	    sVio$ = "Saving .MOD file"
	    CALL WinPercentBox(hwnd, 0, sVio$, 9, 35, 1, iMaxField)

	    sTwoTab$ = SPACE$(12)

	    hFile = FREEFILE
	    OPEN sTempPath$ + "\" + sTempFile$ FOR OUTPUT AS hFile

	    PRINT #hFile, "     REM $INCLUDE: 'STLIBVB.BI'"
	    PRINT #hFile,
	    PRINT #hFile, "     DEFINT A-Z"
	    PRINT #hFile,
	    PRINT #hFile, "     CALL WinSetDefault(TRUE, TRUE, 0, .01, RED, WHITE, BLUE, WHITE, BLACK, WHITE, WHITE, RED)"
	    PRINT #hFile, "     CALL WinDesktop(TRUE, " + CHR$(34) + RTRIM$(sTitle$) + CHR$(34) + ", 176, TRUE)"
	    PRINT #hFile, "     void = " + RTRIM$(sTitle$) + "(0)"
	    PRINT #hFile, "     CALL WinDesktop(FALSE, " + CHR$(34) + CHR$(34) + ", 0, 0)"

	    PRINT #hFile, "DEFINT A-Z"
	    PRINT #hFile, "'       "; STRING$(69, "-"); ""
	    PRINT #hFile, "'        "; RTRIM$(sTitle$); ": Window created by WinScreen.";
	    PRINT #hFile, SPACE$(20); RIGHT$(DATE$, 2); LEFT$(DATE$, 2); MID$(DATE$, 4, 2)
	    PRINT #hFile, "'       "; STRING$(69, "-"); ""

	    IF iEditField = 0 THEN
	       PRINT #hFile, "        SUB "; RTRIM$(sTitle$)
	    ELSE
	       IF StrTrim$(sTypeName$) = "" THEN
		  PRINT #hFile, "        FUNCTION "; RTRIM$(sTitle$); "(iCurField)"
	       ELSE
		  PRINT #hFile, "        FUNCTION "; RTRIM$(sTitle$); "("; sTypeVar$; " AS "; sTypeName$; ",iCurField)"
	       END IF
	    END IF

	    PRINT #hFile, sTwoTab$; "DIM hWnd AS WINDOWTYPE"

	    PRINT #hFile, sTwoTab$; "sVio$ = WinOpenWindow$(hWnd,";
	    PRINT #hFile, iRow1; ","; iCol1; ","; iRow2; ","; iCol2; ","; CHR$(34); RTRIM$(sWTitle$); CHR$(34); ", -1, -1,-1)"

	    FOR iCounter = 1 TO iMaxField
		CALL WinPercentBox(hwnd, 1, "", 0, 0, 0, iCounter)
		SELECT CASE fldList(iCounter).iFieldType
		       CASE IDFSTATIC
			    sRow$ = LTRIM$(STR$(fldList(iCounter).iRow1))
			    sCol$ = LTRIM$(STR$(fldList(iCounter).iCol1))
			    sTxt$ = RTRIM$(fldList(iCounter).sVarName)
			    PRINT #hFile, sTwoTab$; "CALL WinPrint(hWnd,"; sRow$; ",";
			    PRINT #hFile, sCol$; ","; CHR$(34);
			    PRINT #hFile, sTxt$; CHR$(34); ")"
		       CASE IDFLINE
			    sRow$ = LTRIM$(STR$(fldList(iCounter).iRow1))
			    sCol$ = LTRIM$(STR$(fldList(iCounter).iCol1))
			    sTxt$ = STRING$(fldList(iCounter).iColLen, 196)
			    PRINT #hFile, sTwoTab$; "CALL WinPrint(hWnd,"; sRow$; ",";
			    PRINT #hFile, sCol$; ","; CHR$(34);
			    PRINT #hFile, sTxt$; CHR$(34); ")"
		       CASE IDFFRAME
			    sRow1$ = LTRIM$(STR$(fldList(iCounter).iRow1))
			    sCol1$ = LTRIM$(STR$(fldList(iCounter).iCol1))
			    sRow2$ = LTRIM$(STR$(fldList(iCounter).iRowLen))
			    sCol2$ = LTRIM$(STR$(fldList(iCounter).iColLen))
			    PRINT #hFile, sTwoTab$; "CALL WinFrame(hWnd,";
			    PRINT #hFile, CHR$(34); RTRIM$(fldList(iCounter).sFormat); CHR$(34); ",";
			    PRINT #hFile, sRow1$; ","; sCol1$; ","; sRow2$; ","; sCol2$; ",";
			    PRINT #hFile, RTRIM$(fldList(iCounter).sVarName) + ")"
		       CASE ELSE
		END SELECT
	    NEXT iCounter

	    IF iEditField = 0 THEN
	       PRINT #hFile, sTwoTab$; "WHILE INKEY$="; CHR$(34); CHR$(34); ":WEND"
	       PRINT #hFile, sTwoTab$; "CALL WinCloseWindow(hWnd,sVio$)"
	       PRINT #hFile, "        END SUB"
	       CLOSE #hFile
	       CALL WinPercentBox(hwnd, 2, sVio$, 0, 0, 0, 0)
	       EXIT SUB
	    END IF

	    iAntalEdit = 0
	    iDropAntal = 0

	    FOR iCounter = 1 TO iMaxField

		SELECT CASE fldList(iCounter).iFieldType
		       CASE IDFSTATIC, IDFLINE, IDFFRAME
			    GOTO SKIP
		       CASE ELSE
			    IF fldList(iCounter).iFieldEdit = TRUE THEN
			       iAntalEdit = iAntalEdit + 1
			    END IF
		END SELECT

		sRow1$ = LTRIM$(STR$(fldList(iCounter).iRow1))
		sCol1$ = LTRIM$(STR$(fldList(iCounter).iCol1))
		sRowLen$ = LTRIM$(STR$(fldList(iCounter).iRowLen))
		sColLen$ = LTRIM$(STR$(fldList(iCounter).iColLen))
		sFormat$ = RTRIM$(fldList(iCounter).sFormat)
		sVarName$ = RTRIM$(fldList(iCounter).sVarName)


		SELECT CASE fldList(iCounter).iFieldType
		       CASE IDFSTRING
			    iFlag = TRUE
			    sVarName$ = sVarName$ + "$"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    sTemp$ = "StrFormat$(IDSFSTR,SPACE$(" + sColLen$ + ")," + sVarName$ + ")"
		       CASE IDFINT
			    iFlag = TRUE
			    sVarName$ = sVarName$ + "%"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    sTemp$ = "StrFormat$(IDSFINT," + CHR$(34) + sFormat$ + CHR$(34) + ",STR$(" + sVarName$ + "))"
		       CASE IDFFLOAT
			    iFlag = TRUE
			    sVarName$ = sVarName$ + "#"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    sTemp$ = "StrFormat$(IDSFDBL," + CHR$(34) + sFormat$ + CHR$(34) + ",STR$(" + sVarName$ + "))"
		       CASE IDFDATE
			    iFlag = TRUE
			    sVarName$ = sVarName$ + "$"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    sTemp$ = "StrFormat$(IDSFDATE,CHR$(47)," + sVarName$ + ")"
		       CASE IDFTIME
			    iFlag = TRUE
			    sVarName$ = sVarName$ + "$"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    sTemp$ = "StrFormat$(IDSFTIME,CHR$(58)," + sVarName$ + ")"
		       CASE IDFDROP
			    iFlag = TRUE
			    iDropCounter = iDropCounter + 1
			    sVarName$ = sVarName$ + "%"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    sTemp$ = "StrFormat$(IDSFDROP,SPACE$(" + sColLen$ + "),asDrop" + CHR$(64 + iDropCounter) + "$(" + sVarName$ + "))"
		       CASE IDFBUTTON
			    iFlag = FALSE
			    sVarName$ = sVarName$ + "%"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    sTemp$ = CHR$(34) + " < " + sFormat$ + " > " + CHR$(34)
		       CASE IDFBOOL
			    iFlag = TRUE
			    sVarName$ = sVarName$ + "%"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    sTemp$ = "StrFormat$(IDSFBOOL," + CHR$(34) + sFormat$ + CHR$(34) + ",STR$(" + sVarName$ + "))"
		       CASE IDFCHECK
			    iFlag = FALSE
			    sVarName$ = sVarName$ + "%"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    sTemp$ = "StrFormat$(IDSFCHK," + CHR$(34) + sFormat$ + CHR$(34) + ",STR$(" + sVarName$ + "))"
		       CASE IDFOPTION
			    iFlag = FALSE
			    sVarName$ = sVarName$ + "%"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    sTemp$ = "StrFormat$(IDSFOPT," + CHR$(34) + sFormat$ + CHR$(34) + ",STR$(" + sVarName$ + "))"
		       CASE ELSE
		END SELECT

		IF iFlag = TRUE THEN
		   IF fldList(iCounter).iFieldEdit = TRUE THEN
		      PRINT #hFile, sTwoTab$; "CALL WinEditPrint";
		   ELSE
		      PRINT #hFile, sTwoTab$; "CALL WinFieldPrint";
		   END IF
		ELSE
		   PRINT #hFile, sTwoTab$; "CALL WinFieldPrint";
		END IF
		PRINT #hFile, "(hWnd,"; sRow1$; ","; sCol1$; ","; sTemp$ + ")"
SKIP:
	    NEXT

	    FOR iCounter = 1 TO iDropCounter
		PRINT #hFile, sTwoTab$; "'------------ THIS MUST MOVE ------------"
		PRINT #hFile, sTwoTab$; "REDIM asDrop"; CHR$(64 + iCounter); "$(2)"
		PRINT #hFile, sTwoTab$; "      asDrop"; CHR$(64 + iCounter); "$(1)="; CHR$(34); CHR$(34)
		PRINT #hFile, sTwoTab$; "      asDrop"; CHR$(64 + iCounter); "$(2)="; CHR$(34); CHR$(34)
		PRINT #hFile, sTwoTab$; "'----------------------------------------"
	    NEXT


	    IF StrTrim$(sTypeName$) <> "" THEN
	       PRINT #hFile, sTwoTab$; "DIM t" + sTypeVar$ + " AS " + sTypeName$
	       PRINT #hFile, sTwoTab$; "t" + sTypeVar$ + "=" + sTypeVar$
	    END IF
	    PRINT #hFile, sTwoTab$; "IF iCurField=0 THEN"
	    PRINT #hFile, sTwoTab$; "   iCurField=1"
	    PRINT #hFile, sTwoTab$; "END IF"
	    PRINT #hFile, sTwoTab$; "iLastField="; LTRIM$(STR$(iAntalEdit))
	    PRINT #hFile, sTwoTab$; "REDIM aiRet(7)"
	    PRINT #hFile, sTwoTab$; "aiRet(1)=KEYF2"
	    PRINT #hFile, sTwoTab$; "aiRet(2)=KEYESC"
	    PRINT #hFile, sTwoTab$; "aiRet(3)=KEYENTER"
	    PRINT #hFile, sTwoTab$; "aiRet(4)=KEYTAB"
	    PRINT #hFile, sTwoTab$; "aiRet(5)=KEYBTAB"
	    PRINT #hFile, sTwoTab$; "aiRet(6)=KEYDARROW"
	    PRINT #hFile, sTwoTab$; "aiRet(7)=KEYUARROW"
	    PRINT #hFile,
	    PRINT #hFile, sTwoTab$; "iQuit = FALSE"
	    PRINT #hFile, sTwoTab$; "DO"
	    PRINT #hFile, sTwoTab$; "   SELECT CASE iCurField"

	   'CONST IDFSTATIC = 1
	   'CONST IDFLINE = 2
	   'CONST IDFSTRING = 3
	   'CONST IDFINT = 4
	   'CONST IDFFLOAT = 5
	   'CONST IDFDATE = 6
	   'CONST IDFTIME = 7
	   'CONST IDFDROP = 8
	   'CONST IDFBUTTON = 9
	   'CONST IDFBOOL = 10
	   'CONST IDFCHECK = 11
	   'CONST IDFOPTION = 12
	   'CONST IDFLISTBOX = 13
	   'CONST IDFFRAME = 14


	    iAntal = 0
	    iDropCounter = 0

	    FOR iCounter = 1 TO iMaxField

		IF fldList(iCounter).iFieldEdit = FALSE THEN
		   GOTO skip2
		END IF

		iSkip = FALSE
		SELECT CASE fldList(iCounter).iFieldType
		       CASE IDFSTATIC, IDFLINE, IDFFRAME
			    GOTO skip2
		       CASE ELSE
		END SELECT

		sRow1$ = LTRIM$(STR$(fldList(iCounter).iRow1))
		sCol1$ = LTRIM$(STR$(fldList(iCounter).iCol1))
		sRowLen$ = LTRIM$(STR$(fldList(iCounter).iRowLen))
		sColLen$ = LTRIM$(STR$(fldList(iCounter).iColLen))
		sFormat$ = RTRIM$(fldList(iCounter).sFormat)
		sVarName$ = RTRIM$(fldList(iCounter).sVarName)

		iAntal = iAntal + 1

		PRINT #hFile, sTwoTab$; "          CASE"; iAntal
		PRINT #hFile, sTwoTab$; "               ";

		SELECT CASE fldList(iCounter).iFieldType
		       CASE IDFSTRING
			    sVarName$ = sVarName$ + "$"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    PRINT #hFile, "iRet = WinEditString(hWnd,"; sVarName$; ",";
			    PRINT #hFile, sRow1$; ","; sCol1$; ","; sColLen$;
			    PRINT #hFile, ",aiRet(), IDHNULL)"
		       CASE IDFINT
			    sVarName$ = sVarName$ + "%"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    sTemp$ = CHR$(34) + sFormat$ + CHR$(34)
			    PRINT #hFile, "iRet = WinEditInt(hWnd,"; sVarName$; ",";
			    PRINT #hFile, sRow1$; ","; sCol1$; ","; sTemp$;
			    PRINT #hFile, ",aiRet())"

		       CASE IDFFLOAT
			    sVarName$ = sVarName$ + "#"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    sTemp$ = CHR$(34) + sFormat$ + CHR$(34)
			    PRINT #hFile, "iRet = WinEditDbl(hWnd,"; sVarName$; ",";
			    PRINT #hFile, sRow1$; ","; sCol1$; "," + sTemp$;
			    PRINT #hFile, ",aiRet())"

		       CASE IDFDATE
			    sVarName$ = sVarName$ + "$"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    PRINT #hFile, "iRet = WinEditDate(hWnd,"; sVarName$; ",";
			    PRINT #hFile, sRow1$; ","; sCol1$;
			    PRINT #hFile, ",aiRet())"

		       CASE IDFTIME
			    sVarName$ = sVarName$ + "$"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    PRINT #hFile, "iRet = WinEditTime(hWnd,"; sVarName$; ",";
			    PRINT #hFile, sRow1$; ","; sCol1$;
			    PRINT #hFile, ",aiRet())"

		       CASE IDFDROP
			    iDropCounter = iDropCounter + 1
			    sVarName$ = sVarName$ + "%"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    sTemp$ = "StrFormat$(IDSFDROP,SPACE$(" + sColLen$ + "),asDrop" + CHR$(64 + iDropCounter) + "$(" + sVarName$ + "))"
			    PRINT #hFile, "iRet = WinEditDrop(hWnd, asDrop"; CHR$(64 + iDropCounter); "$(),"; sVarName$; ",";
			    PRINT #hFile, sRow1$; ","; sCol1$; ","; sColLen$; ",";
			    PRINT #hFile, "aiRet(), IDHNULL)"

		       CASE IDFBUTTON
			    sTemp$ = CHR$(34) + sFormat$ + CHR$(34)
			    PRINT #hFile, "iRet = WinEditButton(hWnd,"; sTemp$; ",";
			    PRINT #hFile, sRow1$; ","; sCol1$;
			    PRINT #hFile, ","; sVarName$; ",aiRet())"

		       CASE IDFBOOL
			    sVarName$ = sVarName$ + "%"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    sTemp$ = CHR$(34) + sFormat$ + CHR$(34)
			    PRINT #hFile, "iRet = WinEditBool(hWnd,"; sVarName$; ",";
			    PRINT #hFile, sRow1$; ","; sCol1$;
			    PRINT #hFile, ","; sTemp$; ",aiRet())"

		       CASE IDFCHECK
			    sVarName$ = sVarName$ + "%"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    sTemp$ = CHR$(34) + sFormat$ + CHR$(34)
			    PRINT #hFile, "iRet = WinEditCheck(hWnd,"; sVarName$; ",";
			    PRINT #hFile, sRow1$; ","; sCol1$;
			    PRINT #hFile, ","; sTemp$; ",aiRet())"

		       CASE IDFOPTION
			    sVarName$ = sVarName$ + "%"
			    CALL SourceFixVar(sVarName$, sTypeVar$)
			    sTemp$ = CHR$(34) + sFormat$ + CHR$(34)
			    PRINT #hFile, "iRet = WinEditOption(hWnd,"; sVarName$; ",";
			    PRINT #hFile, sRow1$; ","; sCol1$;
			    PRINT #hFile, ","; sTemp$; ",aiRet())"

		       CASE ELSE
		END SELECT
skip2:
	    NEXT
	    PRINT #hFile, sTwoTab$; "          CASE ELSE"
	    PRINT #hFile, sTwoTab$; "   END SELECT"

	    PRINT #hFile, sTwoTab$; "   SELECT CASE iRet"
	    PRINT #hFile, sTwoTab$; "          CASE KEYTAB,KEYDARROW,KEYENTER"
	    PRINT #hFile, sTwoTab$; "               iCurField = iCurField + 1"
	    PRINT #hFile, sTwoTab$; "          CASE KEYBTAB,KEYUARROW"
	    PRINT #hFile, sTwoTab$; "               iCurField = iCurField - 1"
	    PRINT #hFile, sTwoTab$; "          CASE KEYF2"
	    IF StrTrim$(sTypeName$) <> "" THEN
	       PRINT #hFile, sTwoTab$; "               "; sTypeVar$; "="; "t"; sTypeVar$
	    END IF
	    PRINT #hFile, sTwoTab$; "               "; RTRIM$(sTitle$); " = TRUE"
	    PRINT #hFile, sTwoTab$; "               iQuit = TRUE"
	    PRINT #hFile, sTwoTab$; "          CASE KEYESC"
	    PRINT #hFile, sTwoTab$; "               "; RTRIM$(sTitle$); " = FALSE"
	    PRINT #hFile, sTwoTab$; "               iQuit = TRUE"
	    PRINT #hFile, sTwoTab$; "          CASE ELSE"
	    PRINT #hFile, sTwoTab$; "   END SELECT"
	    PRINT #hFile, sTwoTab$; "   IF iCurField > iLastField THEN"
	    PRINT #hFile, sTwoTab$; "      iCurField = 1"
	    PRINT #hFile, sTwoTab$; "   ELSEIF iCurField < 1 THEN"
	    PRINT #hFile, sTwoTab$; "      iCurField = iLastField"
	    PRINT #hFile, sTwoTab$; "   END IF"
	    PRINT #hFile, sTwoTab$; "LOOP WHILE iQuit = FALSE"
		
	    PRINT #hFile, sTwoTab$; "CALL WinCloseWindow(hWnd,sVio$)"
	    PRINT #hFile, "        END FUNCTION"
	    CLOSE #hFile
	    CALL WinPercentBox(hwnd, 2, sVio$, 0, 0, 0, 0)
	END SUB

