REM     *********************************************************************
REM     * WPERBOX.MOD
REM     *********************************************************************
REM     * Part of WIN.MOD library after split
REM     *
REM     *********************************************************************
REM     * 931107: Split...
REM     *--------------------------------------------------------------------
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'
	DEFINT A-Z

'       --------------------------------------------------------------------
'        WinPercentBox: To use in showing for longer jobs.           890801
'       --------------------------------------------------------------------
	SUB WinPercentBox (hwnd AS WINDOWTYPE, iFlag, sRubrik$, iRow, iCol, iStart, iStop)
	    STATIC iStep, iStartValue
	    SELECT CASE iFlag
		   CASE 0
			sVio$ = WinOpenWindow(hwnd, iRow, iCol, 7, 31, sRubrik$, -1, -1, -1)
			sRubrik$ = sVio$
			iStep = iStop - iStart
			iStartValue = iStart
			CALL WinColorPrint(hwnd, 3, 3, hwnd.wbcolor, hwnd.wfcolor, SPACE$(25))
			CALL WinColorPrint(hwnd, 5, 15, hwnd.wfcolor, hwnd.wbcolor, "0%")
		   CASE 1
			iLen = iStop - iStartValue
			iStrLen = (iLen / iStep) * 25
			iPercent = (iLen / iStep) * 100
			CALL WinColorPrint(hwnd, 3, 3, hwnd.efcolor, hwnd.ebcolor, STRING$(iStrLen, ""))
			sTemp$ = LTRIM$(STR$(iPercent)) + "%"
			CALL WinColorPrint(hwnd, 5, 15, hwnd.wfcolor, hwnd.wbcolor, sTemp$)
		   CASE 2
			CALL WinCloseWindow(hwnd, sRubrik$)
			sVio$ = ""
		   CASE ELSE
	    END SELECT
	END SUB

